package com.tin.etbaf.rpu;

//import com.sun.media.sound.HsbParser;

import com.tin.etabf.excelupload.ExcelUpload;
import com.tin.etbaf.rpu.GRPU.MyFilterGRPU;
import com.tin.etbaf.rpu.TextFieldPopup.SelectAll;
import com.tin.tds.lower.util.Hash;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dialog.ModalityType;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.io.*;
import java.math.BigDecimal;
import java.net.URISyntaxException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Hashtable;
import java.util.List;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.Action;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.table.DefaultTableModel;
import javax.swing.text.DefaultEditorKit;
import javax.swing.text.JTextComponent;
import javax.swing.text.TextAction;

public class GrpuUtil {

	static Hashtable htStateCodeName; // added by Akansha
	static Hashtable htAddressChange; // added by Akansha
	static Hashtable htQuarter;
	static Hashtable htFinYear;
	static Hashtable htStateNameCode;
	static Hashtable ministryNameCode;
	static Hashtable ministryCodeName;
	static Image GRPULogo;
	static Image LoadImg;
	static Hashtable subMinistryNameCode;
	static Hashtable subMinistryCodeName;
	static Hashtable employeeTypeCode;
	static Hashtable Annex3employeeTypeCode;//Changes for CR82186 Create file .txt Regular for AnnexureIII
	static Hashtable httypeOfDeductor;
	static Hashtable httypeOfDeductorCode;
	static Hashtable htremittanceCode;
	static Hashtable htremittanceCodeReverse;
	static Hashtable htDDtypeAnnII;
	static Hashtable htDDtypeAnnIII; // By Prajakta
	static Hashtable htOptingForTax; // By Prajakta
	static Hashtable htCountryCode;
	static Hashtable htCountryCodeReverse;
	static Hashtable updationmode;
	static JFrame excelupload;
	static String GRPU_TITLE = "TDS/TCS Return Preparation Utility Ver. 5.0";//RPU 3.8 VersionChange Production problem
	                                                                         //RPU 3.9 VersionChange Chatbot
	                                                                         //RPU 4.0 Changes for CR82186 Version Change FVU 7.5
	                                                                         //RPU 4.1 Changes for CR82683 Version Change FVU 7.6
	                                                                         //RPU 4.2 Changes for CR82937 Version Change FVU 7.7
	                                                                         //RPU 4.3 Changes for CR82937 Version Change FVU 7.8
	                                                                         //RPU 4.4 Changes for CR83190 Version Change FVU 7.9
	                                                                         //RPU 4.5 Changes for CR83677 Version Change FVU 8.0
	                                                                         //RPU 4.6 Changes for CR76613 Version Change FVU 8.1 Only Bug Fix
	                                                                         //RPU 4.7 Changes for CR84532 Version Change FVU 8.2
	                                                                         //RPU 4.8 Changes for CR85831 Version Change FVU 8.3
																			 //RPU 4.9 Changes for CR85567 Version Change FVU 8.4 by Payal
	                                                                         //RPU 5.0 Changes for CR85881 Version Change FVU 8.5
	private static JFrame JdialogFrame;     
	static int TD_FIELD_LENGTH[] = { 0, 0, 0, 0, 10, 75, 25, 25, 25, 25, 25, 0,
			6, 12 };

	private static int iErrCode = 0;
	private static String fhString = "";
	private static int fhFieldCount = 8;
	private static long fhHC;
	private static long fvuFLH;
	private static long samFLH;
	private static long scmFLH;
	private static String fvuVersion = null;
	private static String samVersion = null;
	private static String scmVersion = null;
	private static String recStr;
	private static long fileLevelHC;
	private static BufferedReader br = null;
	private static int recNo = 0;

	//newly added for FRD1.7 by akansha
	public static String validateAlpha ="^[a-zA-Z0-9]+$";
	//********************************************************
	
	GrpuUtil() {
	}

	public static final String[] DDO_REG_NO_MOD = { "A", "B", "C", "D", "E",
			"F", "G" };

	public static boolean isValidCharString(String dataString) {
		if (dataString.trim().equals("") || dataString.trim().length() == 0)
			return false;
		for (int i = 0; i < dataString.length(); i++) {
			if (dataString.charAt(i) == '^')
				return false;
			if (dataString.charAt(i) < ' ' || dataString.charAt(i) > '\177')
				return false;
		}

		return true;
	}

	public static String getFinYr(String finyr) {
		if (finyr.trim().equals("--Select--"))
			return "";
		else
			return finyr;
	}

	public static boolean chkAIN(String AIN) {
		for (int localN = 0; localN < AIN.length(); localN++)
			if (AIN.charAt(localN) == ' ')
				return false;

		return true;
	}

	public static boolean isValidCityName(String cityName) {
		String cName = cityName;
		for (int localN = 0; localN < cName.length(); localN++)
			if ((cName.charAt(localN) <= '@' || cName.charAt(localN) >= '[')
					&& (cName.charAt(localN) <= '`' || cName.charAt(localN) >= '{')
					&& cName.charAt(localN) != '_'
					&& cName.charAt(localN) != ' '
					&& (cName.charAt(localN) <= ',' || cName.charAt(localN) >= '/')
					&& (cName.charAt(localN) <= '\'' || cName.charAt(localN) >= '*'))
				return true;

		return false;
	}

	public static String getMonthCode(String monthName) {
		monthName = monthName.toUpperCase();
		if (monthName.equals("JANUARY"))
			return "01";
		if (monthName.equals("FEBRUARY"))
			return "02";
		if (monthName.equals("MARCH"))
			return "03";
		if (monthName.equals("APRIL"))
			return "04";
		if (monthName.equals("MAY"))
			return "05";
		if (monthName.equals("JUNE"))
			return "06";
		if (monthName.equals("JULY"))
			return "07";
		if (monthName.equals("AUGUST"))
			return "08";
		if (monthName.equals("SEPTEMBER"))
			return "09";
		if (monthName.equals("OCTOBER"))
			return "10";
		if (monthName.equals("NOVEMBER"))
			return "11";
		if (monthName.equals("DECEMBER"))
			return "12";
		else
			return "";
	}

	public static String getMonthName(String MonthCode) {
		if (MonthCode.equals("01"))
			return "January";
		if (MonthCode.equals("02"))
			return "February";
		if (MonthCode.equals("03"))
			return "March";
		if (MonthCode.equals("04"))
			return "April";
		if (MonthCode.equals("05"))
			return "May";
		if (MonthCode.equals("06"))
			return "June";
		if (MonthCode.equals("07"))
			return "July";
		if (MonthCode.equals("08"))
			return "August";
		if (MonthCode.equals("09"))
			return "September";
		if (MonthCode.equals("10"))
			return "October";
		if (MonthCode.equals("11"))
			return "November";
		if (MonthCode.equals("12"))
			return "December";
		else
			return "";
	}

	// Added By Manish
	public static boolean checkOneAlpahNum(String str) {
		if (str != null) {
			int lenghtOfString = str.length();
			if (str.trim().length() != lenghtOfString) {
				return false;
			}
			for (int i = 0; i < lenghtOfString; i++) {
				if (!((str.charAt(i) > 64 && str.charAt(i) < 91) || (str
						.charAt(i) > 96 && str.charAt(i) < 123))) {
					if (str.charAt(i) == 32 || str.charAt(i) == 46)
						return true;
					else
						return false;

				}
			}
		}
		return true;
	}

	public static boolean checkOneAlpah(String str) {
		if (str != null) {
			int lenghtOfString = str.length();
			if (str.trim().length() != lenghtOfString) {
				return false;
			}
			for (int i = 0; i < lenghtOfString; i++) {
				if (!(str.charAt(i) > 47 && str.charAt(i) < 58) // newly changed
																// by cholia
						&& !(str.charAt(i) > 64 && str.charAt(i) < 91)
						&& !(str.charAt(i) > 96 && str.charAt(i) < 123)) // newly
																			// changed
																			// by
																			// cholia
				{
					return false;
				}
			}
		}
		return true;
	}

	// Added By cholia for carret check
	public static boolean iscaret(String field) {
		for (int i = 0; i < field.length(); i++) {
			if (field.charAt(i) == '^') {
				return false;
			}
		}
		return true;

	}

	// cholia end

	public static boolean isInt(String field) {
	//	System.out.println("--PIU---"+field);
		if (field.trim() == "" || field.trim().length() == 0)
		{
		
			return false;
		}
		for (int i = 0; i < field.length(); i++)
		{
			if (field.charAt(i) <= '/' || field.charAt(i) >= ':')
			{
				
				return false;
			}
		}

		try {
			Long.parseLong(field.trim());
		} catch (Exception e) {
			
			return false;
		}
		
		
	
		return Long.parseLong(field.trim()) >= 0L;
	}

	public static boolean isIntwithdot(String field) {
		if (field.trim() == "" || field.trim().length() == 0)
			return false;
		for (int i = 0; i < field.length(); i++)
			if (field.charAt(i) <= '/' || field.charAt(i) >= ':') {
				if (field.charAt(i) == '.')
					return true;
				else
					return false;
			}

		try {
			Long.parseLong(field.trim());
		} catch (Exception e) {
			return false;
		}
		return Long.parseLong(field.trim()) >= 0L;
	}

	public static boolean isIntTds(String field) {
		if (field.trim() == "" || field.trim().length() == 0)
			return false;
		for (int i = 0; i < field.length(); i++)
			if (field.charAt(i) < '0' || field.charAt(i) >= ':') {
				if (field.charAt(i) != '.')
					return false;

			}
		try {
			Long.parseLong(field.trim());
		} catch (Exception e) {
			return false;
		}
		return Long.parseLong(field.trim()) >= 0L;
	}

	// Added By amit cholia for tds amount validation
	public static boolean isDecimal(String data, int Precision) {
		//System.out.println("inside the is decimal");
		String field = data.trim();
		boolean error = false;
		if (field.trim() == "" || field.trim().length() == 0) {
			return true;
		}

		for (int i = 0; i < data.length(); i++) {
			if ((data.charAt(i) < 32 || data.charAt(i) > 127)) {
				return true;
			}
		}
		if (field.charAt(0) == '+' || field.charAt(0) == '-') {
			return true;
		}

		/*
		 * if(field.charAt(0)=='+') { return true; }
		 */
		try {
			Double.parseDouble(field);
		} catch (Exception e) {
			error = true;
			return error;
		}

		int pointCounter = 0;

		char validDecimal;
		int decimalPosition = 0;
		int length = field.length();
		for (int j = 0; j < length; j++) {
			if (!(Character.isDigit(field.charAt(j)))) {
				if (field.charAt(j) == '.') {
					pointCounter++;
					decimalPosition = j;
				} else
					error = true;
			}
		}

		if (field.charAt(0) == '.') {
			return true;
		}

		if (pointCounter == 0)
			error = false;
		else {
			if (Precision == (length - 1) - decimalPosition)
				error = false;
			else
				error = true;
		}

		if (pointCounter > 1)
			error = true;

		else {
			if (decimalPosition != 0) {
				String tds_afterdot = data.substring(decimalPosition + 1);
				if (!tds_afterdot.equalsIgnoreCase("00")) {
					error = true;
				}
			}
		}

		return error;
	}
	
	//new development for FRD1.3 by akansha
	public static boolean isDecimalAnne2(String data, int Precision) {
		//System.out.println("inside the is decimal");
		String field = data.trim();
		boolean error = false;
		if (field.trim() == "" || field.trim().length() == 0) {
			return true;
		}

		for (int i = 0; i < data.length(); i++) {
			if ((data.charAt(i) < 32 || data.charAt(i) > 127)) {
				return true;
			}
		}
		if (field.charAt(0) == '+' || field.charAt(0) == '-') {
			return false;
		}

		/*
		 * if(field.charAt(0)=='+') { return true; }
		 */
		try {
			Double.parseDouble(field);
		} catch (Exception e) {
			error = true;
			return error;
		}

		int pointCounter = 0;

		char validDecimal;
		int decimalPosition = 0;
		int length = field.length();
		for (int j = 0; j < length; j++) {
			if (!(Character.isDigit(field.charAt(j)))) {
				if (field.charAt(j) == '.') {
					pointCounter++;
					decimalPosition = j;
				} else
					error = true;
			}
		}

		if (field.charAt(0) == '.') {
			return true;
		}

		if (pointCounter == 0)
			error = false;
		else {
			if (Precision == (length - 1) - decimalPosition)
				error = false;
			else
				error = true;
		}

		if (pointCounter > 1)
			error = true;

		else {
			if (decimalPosition != 0) {
				String tds_afterdot = data.substring(decimalPosition + 1);
				if (!tds_afterdot.equalsIgnoreCase("00")) {
					error = true;
				}
			}
		}

		return error;
	}
	//****************************************
	
	

	public static boolean isDecimalCreateFile(String data, int Precision) {

		String field = data.trim();
		boolean error = false;
		if (field.trim() == "" || field.trim().length() == 0) {
			return true;
		}

		for (int i = 0; i < data.length(); i++) {
			if ((data.charAt(i) < 32 || data.charAt(i) > 127)) {
				return true;
			}
		}
		if (field.charAt(0) == '+' || field.charAt(0) == '-') {
			return true;
		}

		/*
		 * if(field.charAt(0)=='+') { return true; }
		 */
		//***********************************************
		
		
		//************************************************
		try {
			Double.parseDouble(field);
			
		} catch (Exception e) {
			error = true;
			return error;
		}

		int pointCounter = 0;

		char validDecimal;
		int decimalPosition = 0;
		int length = field.length();
		for (int j = 0; j < length; j++) {
			if (!(Character.isDigit(field.charAt(j)))) {
				if (field.charAt(j) == '.') {
					pointCounter++;
					decimalPosition = j;
				} else
					error = true;
			}
		}

		if (field.charAt(0) == '.') {
			return true;
		}

		if (pointCounter == 0)
			error = false;
		else {
			if (Precision >= (length - 1) - decimalPosition)
				error = false;
			else
				error = true;
		}

		if (pointCounter > 1)
			error = true;

		return error;
	}

	// Added By amit for validation of date

	// Added By choia for the Deduction under 16(ii) and 16(iii)

	public static boolean isDecimalNonZero(String data, int Precision) {

		String field = data.trim();
		boolean error = false;
		if (field.trim() == "" || field.trim().length() == 0) {
			return true;
		}

		for (int i = 0; i < data.length(); i++) {
			if ((data.charAt(i) < 32 || data.charAt(i) > 127)) {
				return true;
			}
		}

		/*
		 * if(field.charAt(0)=='+') { return true; }
		 */
		try {
			Double.parseDouble(field);
		} catch (Exception e) {
			error = true;
			return error;
		}

		int pointCounter = 0;

		char validDecimal;
		int decimalPosition = 0;
		int length = field.length();
		for (int j = 0; j < length; j++) {
			if (!(Character.isDigit(field.charAt(j)))) {
				if (field.charAt(j) == '.') {
					pointCounter++;
					decimalPosition = j;
				} else
					error = true;
			}
		}

		if (field.charAt(0) == '.') {
			return true;
		}

		if (pointCounter == 0)
			error = false;
		else {
			if (Precision == (length - 1) - decimalPosition) // changed here
				error = false;
			else
				error = true;
		}

		if (pointCounter > 1)
			error = true;

		return error;
	}

	// /end cholia

	public static boolean isDate(String dd, String mm, String yy) {
		boolean errorDate = true;

		try {
			if (checkValidation(Integer.parseInt(yy), Integer.parseInt(mm),
					Integer.parseInt(dd))) {
				errorDate = false;
			} else {
				errorDate = true;
			}
		} catch (Exception e) {
			errorDate = true;
		}

		return errorDate;

	}

	public static boolean isDateReg(String dd, String mm, String yy,
			String typeOfStatement) {
		boolean errorDate = true;
		if ("Regular".equals(typeOfStatement)) {
			try {
				if (checkValidation(Integer.parseInt(yy), Integer.parseInt(mm),
						Integer.parseInt(dd))) {
					errorDate = false;
				} else {
					errorDate = true;
				}
			} catch (Exception e) {
				errorDate = true;
			}
		}
		return errorDate;

	}

	public static boolean checkValidation(int iYear, int iMonth, int iDay) {

		if ((iYear < 1800) || (iYear > 2099))
			return false;

		if ((iDay < 1) || (iDay > 31) || (iMonth < 1) || (iMonth > 12))
			return false;

		if (!isLeap(iYear) && (iMonth == 2) && (iDay > 28))
			return false;

		if (isLeap(iYear) && (iMonth == 2) && (iDay > 29))
			return false;

		if (((iMonth == 4) || (iMonth == 6) || (iMonth == 9) || (iMonth == 11))
				&& (iDay > 30))
			return false;

		return true;

	}

	public static boolean isLeap(int year) {
		return ((year % 4 == 0) && (year % 100 != 0 || year % 400 == 0));
	}

	// Amit cholia end for the date

	// Cholia end

	public static int checkCaretCount(String str) {
		int caretPos = 0;
		int caretCount = 0;
		for (int lastCaretPos = str.lastIndexOf("^"); caretPos < lastCaretPos;) {
			caretPos = str.indexOf("^", caretPos + 1);
			caretCount++;
		}

		return caretCount;
	}

	public static String getQtr(String nameMth) {
		nameMth = nameMth.trim();
		if (nameMth.equalsIgnoreCase("April")
				|| nameMth.equalsIgnoreCase("May")
				|| nameMth.equalsIgnoreCase("June"))
			return "Q1";
		if (nameMth.equalsIgnoreCase("July")
				|| nameMth.equalsIgnoreCase("August")
				|| nameMth.equalsIgnoreCase("September"))
			return "Q2";
		if (nameMth.equalsIgnoreCase("October")
				|| nameMth.equalsIgnoreCase("November")
				|| nameMth.equalsIgnoreCase("December"))
			return "Q3";
		if (nameMth.equalsIgnoreCase("January")
				|| nameMth.equalsIgnoreCase("February")
				|| nameMth.equalsIgnoreCase("March"))
			return "Q4";
		else
			return "";
	}

	public static String getStateCode(String state) {
		String code = null;
		code = (String) htStateNameCode.get(state.toUpperCase());
		if (code == null)
			return "";
		else
			return code;
	}

	public static String getUpdationCode(String upcode) {
		String code = null;
		code = (String) updationmode.get(upcode.toUpperCase());
		if (code == null)
			return "";
		else
			return code;
	}

	public static String getEmployeeCode(String employee) {
		String ecode = null;
		ecode = (String) employeeTypeCode.get(employee);
		if (ecode == null)
			return "";
		else
			return ecode;
	}
	
	//Changes for CR82186 Create file .txt Regular for AnnexureIII
	public static String getAnnex3EmployeeCode(String employee) {
		String ecode = null;
		ecode = (String) Annex3employeeTypeCode.get(employee);
		if (ecode == null)
			return "";
		else
			return ecode;
	}

	// Added by Akansha for AnneII
	public static String getDDTypeCode(String ddtype) {
		String ecode = null;
		ecode = (String) htDDtypeAnnII.get(ddtype);
		if (ecode == null)
			return "";
		else
			return ecode;
	}

	// **************************
    // Changes Start by Prajakta
	public static String getDeducteeTypeCode(String noftype) {
		String ecode = null;
		ecode = (String) htDDtypeAnnIII.get(noftype);
		if (ecode == null)
			return "";
		else
			return ecode;
	}
	
/*	public static String getWheatherOptingFroTaxationCode(String ddtype) {
		String ecode = null;
		ecode = (String) htOptingForTax.get(ddtype);
		if (ecode == null)
			return "";
		else
			return ecode;
	}
	// Changes end by Prajakta
*/	
	public static String getMinistryCode(String ministry) {
		String code = null;
		code = (String) ministryNameCode.get(ministry.trim());
		if (code == null)
			return "--Select--";
		else
			return code;
	}

	public static String getMinistryName(String ministry) {
		String code = null;

		code = (String) subMinistryCodeName.get(ministry.trim());
		if (code == null)
			return "--Select--";
		else
			return code;
	}

	// Code Added by Akansha
	public static String getDeductorType(String deductortype) {
		String code = null;

		code = (String) httypeOfDeductor.get(deductortype.trim());
		if (code == null)
			return "--Select--";
		else
			return code;
	}

	// *****************************************************

	//new development for FRD1.3 by Akansha
	
	public static boolean getDropDownSection(String sections,String form){
		if ("24Q".equals(form)) {
			if ("92A".equals(sections))
				return true;
			else if ("92B".equals(sections))
				return true;
			else if ("92C".equals(sections))
				return true;
			else if ("94P".equals(sections))//CR 80278 new section code paste
				return true;
			else if ("--Select--".equals(sections))
				return true;
		}
		else if ("26Q".equals(form)) {

			if ("193".equals(sections))
				return true;
			else if ("194".equals(sections))
				return true;
			else if ("94A".equals(sections))
				return true;
			else if ("94B".equals(sections))
				return true;
			else if ("4BB".equals(sections))
				return true;
			else if ("94C".equals(sections))
				return true;
			else if ("94D".equals(sections))
				return true;
			else if ("4EE".equals(sections))
				return true;
			else if ("94F".equals(sections))
				return true;
			else if ("94G".equals(sections))
				return true;
			else if ("94H".equals(sections))
				return true;
			else if ("94I".equals(sections))
				return true;
			else if ("4IA".equals(sections))
				return true;
			else if ("4IB".equals(sections))
				return true;
			else if ("4IC".equals(sections))
				return true;
			else if ("94J".equals(sections))
				return true;
			else if ("4JA".equals(sections)) //RPU 3.3 start to paste
				return true;
			else if ("4JB".equals(sections))
				return true;
			else if ("94L".equals(sections))
				return true;
			else if ("94N".equals(sections)) //RPU 3.0 start
				return true;
			else if ("94K".equals(sections)) //RPU 3.2 start addition of new section 94K for form 26Q (to paste)
				return true;
			else if ("94O".equals(sections))  //RPU 3.5 start Addition of new section codes to paste
				return true;
			else if ("94Q".equals(sections))  //RPU 3.7 CR 81169 start Addition of new section codes to paste
				return true;
			else if ("4BA".equals(sections)) // new development for FRD1.3 by
				return true;
			else if ("4DA".equals(sections))
				return true;
			else if("LBB".equals(sections))// new development for FRd1.3 by Akansha
				return true;
			else if("2AA".equals(sections))// new development for FRd1.3 by Akansha
				return true;
			else if("LBC".equals(sections)) //new development for FRD1.6 by Akansha
				return true;
			else if ("BA1".equals(sections)) //RPU 3.4 start Addition of new section codes to paste
				return true;
			else if ("BA2".equals(sections))
				return true;
			else if ("4NF".equals(sections))
				return true;
			else if ("94S".equals(sections)) // Rahul CR83190
				return true;
			else if ("94R".equals(sections)) // Rahul CR83190
				return true;
			else if ("4BP".equals(sections)) // Rahul CR83190
				return true;
			else if ("4RP".equals(sections)) // Rahul CR83190
				return true; 
			else if ("4SP".equals(sections)) // Rahul CR83190
				return true;
			else if ("9BA".equals(sections)) //rahul CR84532 26Q Section Code Addition 194BA 
				return true;
			else if ("4AP".equals(sections)) //rahul CR84532 26Q Section Code Addition 194BA-P  4AP
				return true;

			else if ("9FT".equals(sections)) //added by renuka for 9FT
				return true;


			else if ("4NC".equals(sections)) //CR 84532 26Q Section Code Addition 194NC start by Khalid
				return true;

			else if ("--Select--".equals(sections)) 
				return true;
		} 
		else if ("27Q".equals(form)) {

			if ("94E".equals(sections))
				return true;
			if ("94N".equals(sections)) //RPU 3.0 start 
				return true;				//RPU 3.0 end 
			else if ("195".equals(sections))
				return true;
			else if ("96A".equals(sections))
				return true;
			else if ("96B".equals(sections))
				return true;
			else if ("96C".equals(sections))
				return true;
			else if ("96D".equals(sections))
				return true;
			else if ("6DA".equals(sections)) //CR 80278 new section code 196DP
				return true;
			else if ("4LB".equals(sections))
				return true;
			else if ("4LC".equals(sections))
				return true;
			else if ("4LD".equals(sections))
				return true;
			else if ("4BA".equals(sections))
				return true;
			else if("2AA".equals(sections)) // new development for FRd1.3 by Akansha
				return true;
			else if("LBB".equals(sections))// new development for FRd1.3 by Akansha
				return true;
			else if("LBC".equals(sections)) //new development for FRD1.6 by Akansha
				return true;
			else if ("BA1".equals(sections)) //RPU 3.4 start Addition of new section codes to paste
				return true;
			else if ("BA2".equals(sections))
				return true;
			else if ("BA3".equals(sections))
				return true;
			else if ("4NF".equals(sections))
				return true;
			// Addition for section code 194B/194B-P/194BA/194BA-P/194BB/194NC/194N-FT for 27Q by Khalid Khan - Start
			else if ("94B".equals(sections))
				return true;
			else if ("4BP".equals(sections))
				return true;
			else if ("9BA".equals(sections))
				return true;
			else if ("4AP".equals(sections))
				return true;
			else if ("4BB".equals(sections))
				return true;
			else if ("4NC".equals(sections))
				return true;
			else if ("9FT".equals(sections))
				return true;
			// Addition for section code 194B/194B-P/194BA/194BA-P/194BB/194NC/194N-FT for 27Q by Khalid Khan - End
			else if ("--Select--".equals(sections))
				return true;

		} 
		else if ("27EQ".equals(form)) {
			if ("A".equals(sections))
				return true;
			else if ("B".equals(sections))
				return true;
			else if ("C".equals(sections))
				return true;
			else if ("D".equals(sections))
				return true;
			else if ("E".equals(sections))
				return true;
			else if ("F".equals(sections))
				return true;
			else if ("G".equals(sections))
				return true;
			else if ("H".equals(sections))
				return true;
			else if ("I".equals(sections))
				return true;
			else if ("J".equals(sections))
				return true;
			else if ("K".equals(sections))
				return true; 
			//new development for FRD1.6 by akansha
			else if("L".equals(sections))
				return true;
			else if("M".equals(sections))
				return true;
			else if("N".equals(sections))
				return true;
			else if ("O".equals(sections)) //RPU 3.5 start Addition of new section codes to paste
				return true;
			else if ("P".equals(sections))
				return true;
			else if ("Q".equals(sections))
				return true;
			else if ("R".equals(sections))
				return true;
			//***************************************
			else if ("--Select--".equals(sections)) //new development for FRD1.3 by Akansha
				return true;
			else
				return false;
			
		}
			return false;
	}
	
	
	//********************************************************
	
	//new development for FRD1.3 by Akansha
	public static boolean getDropDownCountry(String country) {
		if("AFGHANISTAN".equals(country))
			return true;
		else if("AKROTIRI".equals(country)){
			return true;
		}else if("ALBANIA".equals(country)){
			return true;
		}else if("ALGERIA".equals(country)){
			return true;
		}else if("AMERICAN SAMOA".equals(country)){
			return true;
		}else if("ANDORRA".equals(country)){
			return true;
		}else if("ANGOLA".equals(country)){
			return true;
		}else if("ANGUILLA".equals(country)){
			return true;
		}else if("ANTARCTICA".equals(country)){
			return true;
		}else if("ANTIGUA AND BARBUDA".equals(country)){
			return true;
		}else if("ARGENTINA".equals(country)){
			return true;
		}else if("ARMENIA".equals(country)){
			return true;
		}else if("ARUBA".equals(country)){
			return true;
		}else if("ASHMORE AND CARTIER ISLANDS".equals(country)){
			return true;
		}else if("AUSTRALIA".equals(country)){
			return true;
		}else if("AUSTRIA".equals(country)){
			return true;
		}else if("AZERBAIJAN".equals(country)){
			return true;
		}
		/******************************************************/
		//RPU 2.1, Added new Country code in dropdown list, by Sadhana.
		/*else if("BAHAMAS".equals(country)){
			return true;
		}*/
		/******************************************************/
		else if("BAHRAIN".equals(country)){
			return true;
		}else if("BAILIWICK OF GUERNSEY".equals(country)){
			return true;
		}else if("BAILIWICK OF JERSEY".equals(country)){
			return true;
		}else if("BAKER ISLAND".equals(country)){
			return true;
		}else if("BANGLADESH".equals(country)){
			return true;
		}else if("BARBADOS".equals(country)){
			return true;
		}else if("BELARUS".equals(country)){
			return true;
		}else if("BELGIUM".equals(country)){
			return true;
		}else if("BELIZE".equals(country)){
			return true;
		}else if("BENIN PORTO".equals(country)){
			return true;
		}else if("BERMUDA".equals(country)){
			return true;
		}else if("BHUTAN".equals(country)){
			return true;
		}else if("BOLIVIA".equals(country)){
			return true;
		}else if("BOSNIAAND HERZEGOVINA".equals(country)){
			return true;
		}else if("BOTSWANA".equals(country)){
			return true;
		}else if("BOUVET ISLAND".equals(country)){
			return true;
		}else if("BRAZIL".equals(country)){
			return true;
		}else if("BRITISH INDIAN OCEAN TERRITORY".equals(country)){
			return true;
		}else if("BRUNEI".equals(country)){
			return true;
		}else if("BULGARIA".equals(country)){
			return true;
		}else if("BURKINA FASO".equals(country)){
			return true;
		}else if("BURUNDI".equals(country)){
			return true;
		}else if("CAMBODIA".equals(country)){
			return true;
		}else if("CAMEROON".equals(country)){
			return true;
		}else if("CANADA".equals(country)){
			return true;
		}else if("CAPE VERDE".equals(country)){
			return true;
		}else if("CAYMAN ISLANDS".equals(country)){
			return true;
		}else if("CENTRAL AFRICAN REPUBLIC".equals(country)){
			return true;
		}else if("CHAD".equals(country)){
			return true;
		}else if("CHILE".equals(country)){
			return true;
		}else if("CHINA".equals(country)){
			return true;
		}else if("CHRISTMAS ISLAND".equals(country)){
			return true;
		}else if("CLIPPERTON ISLAND".equals(country)){
			return true;
		}else if("COCOS (KEELING) ISLANDS".equals(country)){
			return true;
		}else if("COLOMBIA".equals(country)){
			return true;
		}else if("COMMONWEALTH OF PUERTO RICO".equals(country)){
			return true;
		}else if("COMMONWEALTH OF THE NORTHERN MARIANA ISLANDS".equals(country)){
			return true;
		}else if("COMOROS".equals(country)){
			return true;
		}else if("CONGO,DEMOCRATIC REPUBLIC OF THE".equals(country)){
			return true;
		}else if("CONGO,REPUBLIC OF THE".equals(country)){
			return true;
		}else if("COOK ISLANDS".equals(country)){
			return true;
		}else if("CORAL SEA ISLANDS".equals(country)){
			return true;
		}else if("CORAL SEA ISLANDS TERRITORY".equals(country)){
			return true;
		}else if("COSTA RICA".equals(country)){
			return true;
		}else if("COTE D'IVOIRE".equals(country)){
			return true;
		}else if("CROATIA".equals(country)){
			return true;
		}else if("CUBA".equals(country)){
			return true;
		}else if("CYPRUS".equals(country)){
			return true;
		}else if("CZECH REPUBLIC".equals(country)){
			return true;
		}else if("DENMARK".equals(country)){
			return true;
		}else if("DEPARTMENTAL COLLECTIVITY OF MAYOTTE".equals(country)){
			return true;
		}else if("DHEKELIA".equals(country)){
			return true;
		}else if("DJIBOUTI".equals(country)){
			return true;
		}else if("DOMINICA".equals(country)){
			return true;
		}else if("DOMINICAN REPUBLIC".equals(country)){
			return true;
		}else if("EAST TIMOR (TIMORLASTE)".equals(country)){
			return true;
		}else if("ECUADOR".equals(country)){
			return true;
		}else if("EGYPT".equals(country)){
			return true;
		}else if("ELSALVADOR".equals(country)){
			return true;
		}else if("EQUATORIAL GUINEA".equals(country)){
			return true;
		}else if("ERITREA".equals(country)){
			return true;
		}else if("ESTONIA".equals(country)){
			return true;
		}else if("ETHIOPIA".equals(country)){
			return true;
		}else if("FALKLAND ISLANDS (ISLAS MALVINAS)".equals(country)){
			return true;
		}else if("FAROE ISLANDS".equals(country)){
			return true;
		}else if("FIJI".equals(country)){
			return true;
		}else if("FINLAND".equals(country)){
			return true;
		}else if("FRANCE".equals(country)){
			return true;
		}else if("FRENCH GUIANA".equals(country)){
			return true;
		}else if("FRENCH POLYNESIA".equals(country)){
			return true;
		}else if("FRENCH SOUTHERN ISLANDS".equals(country)){
			return true;
		}else if("GABON".equals(country)){
			return true;
		}else if("GEORGIA".equals(country)){
			return true;
		}else if("GERMANY".equals(country)){
			return true;
		}else if("GEURNSEY".equals(country)){
			return true;
		}else if("GHANA".equals(country)){
			return true;
		}else if("GIBRALTAR".equals(country)){
			return true;
		}else if("GREECE".equals(country)){
			return true;
		}else if("GREENLAND".equals(country)){
			return true;
		}else if("GRENADA".equals(country)){
			return true;
		}else if("GUADELOUPE".equals(country)){
			return true;
		}else if("GUAM".equals(country)){
			return true;
		}else if("GUATEMALA".equals(country)){
			return true;
		}else if("GUERNSEY".equals(country)){
			return true;
		}else if("GUINEA".equals(country)){
			return true;
		}else if("GUINEABISSAU".equals(country)){
			return true;
		}else if("GUYANA".equals(country)){
			return true;
		}else if("HAITI".equals(country)){
			return true;
		}else if("HEARD ISLAND AND MCDONALD ISLANDS".equals(country)){
			return true;
		}else if("HONDURAS".equals(country)){
			return true;
		}else if("HONG KONG".equals(country)){
			return true;
		}else if("HOWLAND ISLAND".equals(country)){
			return true;
		}else if("HUNGARY".equals(country)){
			return true;
		}else if("ICELAND".equals(country)){
			return true;
		}else if("INDIA".equals(country)){
			return true;
		}else if("INDONESIA".equals(country)){
			return true;
		}else if("IRAN".equals(country)){
			return true;
		}else if("IRAQ".equals(country)){
			return true;
		}else if("IRELAND".equals(country)){
			return true;
		}else if("ISLE OF MAN".equals(country)){
			return true;
		}else if("ISRAEL".equals(country)){
			return true;
		}else if("ITALY".equals(country)){
			return true;
		}else if("JAMAICA".equals(country)){
			return true;
		}else if("JAN MAYEN".equals(country)){
			return true;
		}else if("JAPAN".equals(country)){
			return true;
		}else if("JARVIS ISLAND".equals(country)){
			return true;
		}else if("JERSEY".equals(country)){
			return true;
		}else if("JOHNSTON ATOLL".equals(country)){
			return true;
		}else if("JORDAN".equals(country)){
			return true;
		}else if("KAZAKHSTAN".equals(country)){
			return true;
		}else if("KENYA".equals(country)){
			return true;
		}else if("KINGMAN REEF".equals(country)){
			return true;
		}else if("KIRIBATI".equals(country)){
			return true;
		}else if("KOREA, NORTH".equals(country)){
			return true;
		}else if("KOREA, SOUTH".equals(country)){
			return true;
		}else if("KOSOVO".equals(country)){
			return true;
		}else if("KUWAIT".equals(country)){
			return true;
		}else if("KYRGYZSTAN".equals(country)){
			return true;
		}else if("LAOS".equals(country)){
			return true;
		}else if("LATVIA".equals(country)){
			return true;
		}else if("LEBANON".equals(country)){
			return true;
		}else if("LESOTHO".equals(country)){
			return true;
		}else if("LIBERIA".equals(country)){
			return true;
		}else if("LIBYA".equals(country)){
			return true;
		}else if("LIECHTENSTEIN".equals(country)){
			return true;
		}else if("LITHUANIA".equals(country)){
			return true;
		}else if("LUXEMBOURG".equals(country)){
			return true;
		}else if("MACAU".equals(country)){
			return true;
		}else if("MACEDONIA".equals(country)){
			return true;
		}else if("MADAGASCAR".equals(country)){
			return true;
		}else if("MALAWI".equals(country)){
			return true;
		}else if("MALAYSIA".equals(country)){
			return true;
		}else if("MALAYSIA (LABUAN)".equals(country)){
			return true;
		}else if("MALDIVES".equals(country)){
			return true;
		}else if("MALI".equals(country)){
			return true;
		}else if("MALTA".equals(country)){
			return true;
		}else if("MARSHALLISLANDS".equals(country)){
			return true;
		}else if("MARTINIQUE".equals(country)){
			return true;
		}else if("MAURITANIA".equals(country)){
			return true;
		}else if("MAURITIUS".equals(country)){
			return true;
		}else if("MAYOTTE".equals(country)){
			return true;
		}else if("UNITED MEXICAN STATES".equals(country)){
			return true;
		}else if("MICRONESIA, FEDERATED STATES OF".equals(country)){
			return true;
		}else if("MIDWAY ISLANDS".equals(country)){
			return true;
		}else if("MOLDOVA".equals(country)){
			return true;
		}else if("MONACO".equals(country)){
			return true;
		}else if("MONGOLIA".equals(country)){
			return true;
		}else if("MONTENEGRO".equals(country)){
			return true;
		}else if("MONTSERRAT".equals(country)){
			return true;
		}else if("MOROCCO".equals(country)){
			return true;
		}else if("MOZAMBIQUE".equals(country)){
			return true;
		}else if("MYANMAR (BURMA)".equals(country)){
			return true;
		}else if("NAMIBIA".equals(country)){
			return true;
		}else if("NAURU".equals(country)){
			return true;
		}else if("NAVASSA ISLAND".equals(country)){
			return true;
		}else if("NEPAL".equals(country)){
			return true;
		}else if("NETHERLANDS".equals(country)){
			return true;
		}else if("NETHERLANDS ANTILLES".equals(country)){
			return true;
		}else if("NEW CALEDONIA".equals(country)){
			return true;
		}else if("NEWZEALAND".equals(country)){
			return true;
		}else if("NICARAGUA".equals(country)){
			return true;
		}else if("NIGER".equals(country)){
			return true;
		}else if("NIGERIA".equals(country)){
			return true;
		}else if("NIUE".equals(country)){
			return true;
		}else if("NORFOLK ISLAND".equals(country)){
			return true;
		}else if("NORTHERN MARIANA ISLANDS".equals(country)){
			return true;
		}else if("NORWAY".equals(country)){
			return true;
		}else if("OMAN".equals(country)){
			return true;
		}else if("PAKISTAN".equals(country)){
			return true;
		}else if("PALAU".equals(country)){
			return true;
		}else if("PALMYRA ATOLL".equals(country)){
			return true;
		}else if("PANAMA".equals(country)){
			return true;
		}else if("PAPUA NEW GUINEA".equals(country)){
			return true;
		}else if("PARACEL ISLANDS".equals(country)){
			return true;
		}else if("PARAGUAY".equals(country)){
			return true;
		}else if("PERU".equals(country)){
			return true;
		}else if("PHILIPPINES".equals(country)){
			return true;
		}else if("PITCAIRN ISLANDS".equals(country)){
			return true;
		}else if("PITCAIRN, HENDERSON, DUCIE, AND OENO ISLANDS".equals(country)){
			return true;
		}else if("POLAND".equals(country)){
			return true;
		}else if("PORTUGAL".equals(country)){
			return true;
		}else if("PUERTO RICO".equals(country)){
			return true;
		}else if("QATAR".equals(country)){
			return true;
		}else if("REUNION".equals(country)){
			return true;
		}else if("ROMANIA".equals(country)){
			return true;
		}else if("RUSSIA".equals(country)){
			return true;
		}else if("RWANDA".equals(country)){
			return true;
		}else if("SAINT BARTHELEMY".equals(country)){
			return true;
		}else if("SAINT HELENA".equals(country)){
			return true;
		}else if("SAINT KITTS AND NEVIS".equals(country)){
			return true;
		}else if("SAINT LUCIA".equals(country)){
			return true;
		}else if("SAINT MARTIN".equals(country)){
			return true;
		}else if("SAINT PIERRE AND MIQUELON".equals(country)){
			return true;
		}else if("SAINT VINCENT AND THE GRENADINES".equals(country)){
			return true;
		}else if("SAMOA".equals(country)){
			return true;
		}else if("SANMARINO".equals(country)){
			return true;
		}else if("SAO TOME AND PRINCIPE".equals(country)){
			return true;
		}else if("SAUDI ARABIA".equals(country)){
			return true;
		}else if("SENEGAL".equals(country)){
			return true;
		}else if("SERBIA".equals(country)){
			return true;
		}else if("SEYCHELLES".equals(country)){
			return true;
		}else if("SIERRA LEONE".equals(country)){
			return true;
		}else if("SINGAPORE".equals(country)){
			return true;
		}else if("SLOVAKIA".equals(country)){
			return true;
		}else if("SLOVENIA".equals(country)){
			return true;
		}else if("SOLOMON ISLANDS".equals(country)){
			return true;
		}else if("SOMALIA".equals(country)){
			return true;
		}else if("SOUTH AFRICA".equals(country)){
			return true;
		}else if("SOUTH GEORGIA AND SOUTH SANDWICH ISLANDS".equals(country)){
			return true;
		}else if("SPRATLY ISLANDS".equals(country)){
			return true;
		}else if("SPAIN".equals(country)){
			return true;
		}else if("SRI LANKA".equals(country)){
			return true;
		}else if("ST. VINCENT & GRENADINES".equals(country)){
			return true;
		}else if("SUDAN".equals(country)){
			return true;
		}else if("SURINAME".equals(country)){
			return true;
		}else if("SVALBARD".equals(country)){
			return true;
		}else if("SWAZILAND".equals(country)){
			return true;
		}else if("SWEDEN".equals(country)){
			return true;
		}else if("SWITZERLAND".equals(country)){
			return true;
		}else if("SYRIA".equals(country)){
			return true;
		}else if("TAIWAN".equals(country)){
			return true;
		}else if("TAJIKISTAN".equals(country)){
			return true;
		}else if("TANZANIA".equals(country)){
			return true;
		}else if("TERRITORIAL COLLECTIVITY OF ST. PIERRE & MIQUELON".equals(country)){
			return true;
		}else if("TERRITORY OF AMERICAN SAMOA".equals(country)){
			return true;
		}else if("TERRITORY OF ASHMORE AND CARTIER ISLANDS".equals(country)){
			return true;
		}else if("TERRITORY OF CHRISTMAS ISLAND".equals(country)){
			return true;
		}else if("TERRITORY OF COCOS (KEELING) ISLANDS".equals(country)){
			return true;
		}else if("TERRITORY OF GUAM".equals(country)){
			return true;
		}else if("TERRITORY OF HEARD ISLAND & MCDONALD ISLANDS".equals(country)){
			return true;
		}else if("TERRITORY OF NORFOLK ISLAND".equals(country)){
			return true;
		}else if("THAILAND".equals(country)){
			return true;
		}else if("THE BAHAMAS".equals(country)){
			return true;
		}else if("THE GAMBIA".equals(country)){
			return true;
		}else if("TOGO".equals(country)){
			return true;
		}else if("TOKELAU".equals(country)){
			return true;
		}else if("TONGA".equals(country)){
			return true;
		}else if("TRINIDAD AND TOBAGO".equals(country)){
			return true;
		}else if("TUNISIA".equals(country)){
			return true;
		}else if("TURKEY".equals(country)){
			return true;
		}else if("TURKMENISTAN".equals(country)){
			return true;
		}else if("TURKS AND CAICOS ISLANDS".equals(country)){
			return true;
		}else if("TUVALU".equals(country)){
			return true;
		}else if("UGANDA".equals(country)){
			return true;
		}else if("UKRAINE".equals(country)){
			return true;
		}else if("UNITED ARAB EMIRATES".equals(country)){
			return true;
		}else if("UNITED KINGDOM".equals(country)){
			return true;
		}else if("UNITED STATES VIRGIN ISLANDS".equals(country)){
			return true;
		}else if("UNITED STATES OF AMERICA".equals(country)){
			return true;
		}else if("URUGUAY".equals(country)){
			return true;
		}else if("UZBEKISTAN".equals(country)){
			return true;
		}else if("VANUATU".equals(country)){
			return true;
		}else if("VATICAN CITY (HOLYSEE)".equals(country)){
			return true;
		}else if("VENEZUELA".equals(country)){
			return true;
		}else if("VIETNAM".equals(country)){
			return true;
		}else if("VIRGIN ISLANDS, BRITISH".equals(country)){
			return true;
		}else if("VIRGIN ISLANDS, U.S.".equals(country)){
			return true;
		}else if("WAKE ISLAND".equals(country)){
			return true;
		}else if("WALLIS AND FUTUNA".equals(country)){
			return true;
		}else if("WESTERN SAHARA".equals(country)){
			return true;
		}else if("YEMEN".equals(country)){
			return true;
		}else if("ZAMBIA".equals(country)){
			return true;
		}else if("ZIMBABWE".equals(country)){
			return true;
		}else if("COMBODIA".equals(country)){
			return true;
		}else if("CONGO".equals(country)){
			return true;
		}else if("IVORY COAST".equals(country)){
			return true;
		}else if("WEST INDIES".equals(country)){
			return true;
		}else if("BRITISH VIRGIN ISLANDS".equals(country)){
			return true;
		}
		else if("--Select--".equals(country))
			return true;
		else 
			return false;
	}
		
	public static boolean getDropDownRemittance(String rtcode) {
		//new development for FRD1.3 by Akansha
//		if("COMMISSION".equals(rtcode))
//			return true;
//		else 
			if("INTEREST PAYMENT".equals(rtcode)){
			return true;
			//new development for FRD1.3 by Akansha
//		}else if("PAYMENTS TO SPORTS PERSON & ARTISTS".equals(rtcode)){
//			return true;
//		}else if("WINNING FROM HORSE RACES.".equals(rtcode)){
//			return true;
//		}else if("WINNING FROM LOTTERIES, CROSSWORD PUZZLES, CARD GAMES AND OTHER GAMES OF ANY SORT.".equals(rtcode)){
//			return true;
		}else if("FEES FOR TECHNICAL SERVICES/ FEES FOR INCLUDED SERVICES".equals(rtcode)){
			return true;
		}else if("ROYALTY".equals(rtcode)){
			return true;
		}else if("DIVIDEND".equals(rtcode)){
			return true;
		}else if("INVESTMENT INCOME".equals(rtcode)){
			return true;
		}else if("LONG TERM CAPITAL GAINS (Others)".equals(rtcode)){
			return true;
		}else if("LONG TERM CAPITAL GAIN u/s 115E IN CASE OF NON RESIDENT INDIAN CITIZEN".equals(rtcode)){//rahul CR84532 27Q nature of remmittance 
			return true;
		}else if("LONG TERM CAPITAL GAIN u/s 112".equals(rtcode)){//rahul CR84532 27Q nature of remmittance 
			return true;
		}else if("LONG TERM CAPITAL GAIN u/s 112(1)(c)(iii)".equals(rtcode)){//rahul CR84532 27Q nature of remmittance 
			return true;
		}else if("LONG TERM CAPITAL GAIN u/s 112A".equals(rtcode)){//rahul CR84532 27Q nature of remmittance 
				return true;
		}else if("SHORT TERM CAPITAL GAIN u/s 111A".equals(rtcode)){//rahul CR84532 27Q nature of remmittance 
			return true;
		}else if("SHORT TERM CAPITAL GAINS".equals(rtcode)){
				return true;
			
		}else if("OTHER INCOME / OTHER (NOT IN THE NATURE OF INCOME)".equals(rtcode)){
			return true;
		}else if("--Select--".equals(rtcode))//newly developed for FRD1.5 by akansha
			return true;
		else
			return false;
	}
		public static boolean getDropDownRemarks(String remarks){
			if("A".equals(remarks))
				return true;
			else if("B".equals(remarks))
				return true;
			else if("C".equals(remarks))
				return true;
			else if("T".equals(remarks))
				return true;
			else if("Y".equals(remarks))
				return true;
			else if("S".equals(remarks))
				return true;
			else if("Z".equals(remarks))
				return true;
			else if("--Select--".equals(remarks))
				return true;
			//newly developed for FRD1.5 Ver1.5 by akansha
			else if("B - In case of 15G/15H".equals(remarks))
				return true;
			//RPU 2.9 start..... bug b fix.
			else if("R".equals(remarks))
				return true;
			//RPU 3.1 start
			else if("N".equals(remarks))
				return true;
			else if("O".equals(remarks))  //RPU 3.4 start Addition of new remark  to paste
				return true;
			else if("E".equals(remarks))
				return true;
			else if("M".equals(remarks))
				return true;
			else if("G".equals(remarks))
				return true;
			else if("D".equals(remarks))  //RPU 3.5 start Addition of new remark  to paste
				return true;
			else if("F".equals(remarks))
				return true;
			else if("H".equals(remarks) ||"I".equals(remarks) ||"P".equals(remarks) ||"Q".equals(remarks))//CR 80278 new remarks paste
				return true;
			else if("U".equals(remarks)) //RPU 3.7 CR 81169
				return true;
			else if("J".equals(remarks))
				return true;
			else
				return false;
		}
	//********************************************************
	
	// Code Added by Akansha
	public static String getRemittanceCode(String remittancecode) {
		String code = null;

		code = (String) htremittanceCode.get(remittancecode.trim());
		if (code == null)
			return "--Select--";
		else
			return code;
	}

	public static String getRemittanceCodeReverse(String remittance) {
		String code = null;

		code = (String) htremittanceCodeReverse.get(remittance.trim());
		if (code == null)
			return "";
		else
			return code;
	}

	// *****************************************************

	// Code Added by Akansha
	public static String getCountryCode(String countrycode) {
		String code = null;

		code = (String) htCountryCode.get(countrycode.trim());
		if (code == null)
			return "--Select--";
		else
			return code;
	}

	public static String getCountryCodeReverse(String country) {
		String code = null;

		code = (String) htCountryCodeReverse.get(country.trim());
		if (code == null)
			return "";
		else
			return code;
	}

	// *****************************************************
	// ****************** coded by akansha for get Deductortype code************

	public static String getDeductorCode(String deductortype) {
		String code = null;

		code = (String) httypeOfDeductorCode.get(deductortype.trim());
		if (code == null)
			return "";
		else
			return code;
	}

	//

	public static String getSubMinistryCode(String data) {
		String code = null;
		code = (String) subMinistryNameCode.get(data);
		if (code == null)
			return "";
		else
			return code;
	}

	public static String getSubMinistryName(String data) {
		String code = null;
		code = (String) subMinistryCodeName.get(data);
		if (code == null)
			return "--Select--";
		else
			return code;
	}

	public static String getStateName(String statecode) {
		String str = null;
		str = (String) htStateCodeName.get(statecode);
		if (str == null)
			return "--Select--";
		else
			return str;
	}

	// For auto select of isAddressChange, isRevised, hasRegularStatement

	public static String getYesNoOption(String option) {

		String str = null;
		str = (String) htAddressChange.get(option);
		if (str == null)
			return "--Select--";
		else
			return str;
	}

	// **************************************************************

	// For auto select of year onload added by Akansha
	public static String getFinYear(String finYear) {
		String str = null;
		str = (String) htFinYear.get(finYear);
		if (str == null)
			return "";
		else
			return str;
	}

	// *********************************

	// For auto select of year onload added by Akansha
	public static String getQuarter(String quarter) {
		String str = null;
		str = (String) htQuarter.get(quarter);
		if (str.equals("--Select--"))
			return "--Select--";
		else
			return str;
	}

	// **********************************

	public static String NatOFDedn(String getDedTyp) {
		getDedTyp = getDedTyp.trim();
		if (getDedTyp.equals("TDS-SAL (24Q)"))
			return "24Q";
		if (getDedTyp.equals("TDS-NON-SAL (26Q)"))
			return "26Q";
		if (getDedTyp.equals("TDS-NR (27Q)"))
			return "27Q";
		if (getDedTyp.equals("TCS (27EQ)"))
			return "27EQ";
		else
			return "--Select--";
	}

	public static String Open_NatOFDedn(String getDedTyp) {
		getDedTyp = getDedTyp.trim();
		if (getDedTyp.equals("24Q"))
			return "TDS-SAL (24Q)";
		if (getDedTyp.equals("26Q"))
			return "TDS-NON-SAL (26Q)";
		if (getDedTyp.equals("27Q"))
			return "TDS-NR (27Q)";
		if (getDedTyp.equals("27EQ"))
			return "TCS (27EQ)";
		else
			return "--Select--";
	}

	public static List<String> tokeniseBH(String strBH) {
		List<String> bharray = new ArrayList();
		int i = 0;
		int caretPos = 0;
		int nxtCaretPos = 0;
		int lastCaretPos;

		for (lastCaretPos = strBH.lastIndexOf("^"); caretPos < lastCaretPos;) {

			nxtCaretPos = strBH.indexOf("^", caretPos + 1);
			bharray.add(strBH.substring(caretPos + 1, nxtCaretPos));
			//System.out.println("bh["+i+"]=="+caretPos+"=="+nxtCaretPos+"=="+strBH.substring(caretPos + 1, nxtCaretPos));
			caretPos = nxtCaretPos;
			i++;
		}

		bharray.add(strBH.substring(lastCaretPos + 1, strBH.length()));
		return bharray;
	}

	// Added by Akansha
	// To tokenize the CD,DD,SD

	public static String[] tokeniseFH(String strFH) {
		int count = strFH.lastIndexOf("^");
		String FHReg[] = new String[count];
		int i = 1;
		int caretPos = 0;
		int nxtCaretPos = 0;
		int lastCaretPos;
		FHReg[0] = strFH.substring(0, 1);
		for (lastCaretPos = strFH.lastIndexOf("^"); caretPos < lastCaretPos;) {
			nxtCaretPos = strFH.indexOf("^", caretPos + 1);
			FHReg[i] = strFH.substring(caretPos + 1, nxtCaretPos);
			caretPos = nxtCaretPos;
			i++;
		}

		FHReg[i] = strFH.substring(lastCaretPos + 1, strFH.length());
		return FHReg;
	}

	// *****************************************************************
	public static String[] tokenise(String str) {
	//newly added for FRD1.6 by akansha
		//int strLen = 67;
		/****************** Added for 2.7 Start ********************/
		//int strLen = 88;
		//RPU 2.9 start
		int strLen = 106; //rahul CR84532 24Q added 80CCH and 80CCH(1)  before it was 101
		//RPU 2.9 end
		/****************** Added for 2.7 End ********************/
		String TD[] = new String[strLen];// to be fixed
		int i = 0;
		int caretPos = 0;
		int nxtCaretPos = 0;
		int lastCaretPos;
		for (lastCaretPos = str.lastIndexOf("^"); caretPos < lastCaretPos;) {
			nxtCaretPos = str.indexOf("^", caretPos + 1);
			TD[i] = str.substring(caretPos + 1, nxtCaretPos);
			caretPos = nxtCaretPos;
			i++;

		}

		TD[i] = str.substring(lastCaretPos + 1, str.length());
		return TD;
	}

	public static String[] tokeniseAnnI(String str) {

		int strLen = 62; //rpu 3.1 start original value 51 //rahul CR84532 old value 58
		/*String[] strArray = str.split("\\^");
		int strLen =  strArray.length;*/
		String TD[] = new String[strLen];// to be fixed
		int i = 0;
		int caretPos = 0;
		int nxtCaretPos = 0;
		int lastCaretPos;
		for (lastCaretPos = str.lastIndexOf("^"); caretPos < lastCaretPos;) {
			nxtCaretPos = str.indexOf("^", caretPos + 1);
			TD[i] = str.substring(caretPos + 1, nxtCaretPos);
			caretPos = nxtCaretPos;
			
			i++;

		}
	
		TD[i] = str.substring(lastCaretPos + 1, str.length());
	
		return TD;
	}

	public static int getLength_TDField(int col) {
		if (col >= TD_FIELD_LENGTH.length)
			return 0;
		else
			return TD_FIELD_LENGTH[col];
	}

	public static String perTDtaxAmt(String TDtaxVal) {
		String Dec_TDtaxVal = "";
		int decimalPlaces = 2;
		try {
			BigDecimal TDtaxAmount;
			if (TDtaxVal == null || TDtaxVal.toString().trim().equals("")
					|| TDtaxVal.toString().trim().equals(null))
				return "";
			else
				TDtaxAmount = new BigDecimal(TDtaxVal);
			TDtaxAmount = TDtaxAmount.setScale(decimalPlaces, 1);
			Dec_TDtaxVal = String.valueOf(TDtaxAmount);
		} catch (Exception e) {
			e.printStackTrace();
			return "0.00";
		}
		return Dec_TDtaxVal;
	}

	public static String TotalOfTaxDedColl(DefaultTableModel model) {
		BigDecimal totalTaxBH = new BigDecimal("0");
		BigDecimal bdTotalTaxTD = new BigDecimal("0");
		String strTotalTaxBH = "0";
		int decimalPlaces = 2;
		try {
			for (int i = 0; i < model.getRowCount(); i++) {
				Object strTotalTaxTD = model.getValueAt(i, 19);
				if (strTotalTaxTD == null
						|| strTotalTaxTD.toString().trim().length() == 0)
					strTotalTaxTD = "0";
				bdTotalTaxTD = new BigDecimal(strTotalTaxTD.toString().trim());
				totalTaxBH = totalTaxBH.add(bdTotalTaxTD);
			}

			totalTaxBH = totalTaxBH.setScale(decimalPlaces, 1);
			strTotalTaxBH = String.valueOf(totalTaxBH);
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return strTotalTaxBH;
	}

	public static String TotalOfTaxDedCollNew(DefaultTableModel model,
			ArrayList saveDDOArrayList) {
		BigDecimal totalTaxBH = new BigDecimal("0");
		BigDecimal bdTotalTaxTD = new BigDecimal("0");
		String strTotalTaxBH = "0";
		int decimalPlaces = 2;
		try {
			for (int i = 0; i < model.getRowCount(); i++) {
				Object strTotalTaxTD = model.getValueAt(i, 19);
				String revMode = (String) model.getValueAt(i, 2);
				// Added if condition to get the tax of only newly added rows
				if (revMode.equalsIgnoreCase("Add")) {
					if (strTotalTaxTD == null
							|| strTotalTaxTD.toString().trim().length() == 0)
						strTotalTaxTD = "0";
					bdTotalTaxTD = new BigDecimal(strTotalTaxTD.toString()
							.trim());
					totalTaxBH = totalTaxBH.add(bdTotalTaxTD);
				} else if (revMode.equalsIgnoreCase("Update")) {
					Object[] transObject = (Object[]) saveDDOArrayList.get(i);
					String lastAmount = transObject[15].toString();
					double lastAmountInDouble = 0;
					double strTotalDouble = 0;
					try {
						lastAmountInDouble = Double.parseDouble(lastAmount);

					} catch (Exception e) {
						e.printStackTrace();
						lastAmountInDouble = 0;

					}
					try {

						strTotalDouble = Double.parseDouble(strTotalTaxTD
								.toString());
					} catch (Exception e) {
						e.printStackTrace();
						strTotalDouble = 0;
					}

					double finalAmount = (strTotalDouble - lastAmountInDouble);

					//System.out.println(finalAmount + "Final Amount"
					//		+ lastAmountInDouble + strTotalDouble);

					if (strTotalTaxTD == null
							|| strTotalTaxTD.toString().trim().length() == 0)
						strTotalTaxTD = "0";
					bdTotalTaxTD = new BigDecimal(finalAmount);
					totalTaxBH = totalTaxBH.add(bdTotalTaxTD);
				}
			}

			totalTaxBH = totalTaxBH.setScale(decimalPlaces, 1);
			strTotalTaxBH = String.valueOf(totalTaxBH);
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return strTotalTaxBH;
	}

	public static boolean isValidEmail(String data) {
		String regEmail = "^[_A-Za-z0-9-]+(\\.[_A-Za-z0-9-]+)*@[A-Za-z0-9]+(\\.[A-Za-z0-9]+)*(\\.[A-Za-z]{2,})$";
		String field = data.trim();
		if (field.matches(regEmail)) {
			return true;
		} else {
			return false;

		}

		
	}

	/*public static long getHashofLine(String str) {
		long lineHash = 0L;
		try {
			Hash hash = new Hash();
			lineHash = hash.hashCode(str, false);
		} catch (Exception e) {
			e.printStackTrace();
			return 0L;
		}
		return lineHash;
	}*/

	/*public static long getFileHash(String fileName) {
		long fileHash = 0L;
		long LineNum = 0L;
		String str = "";
		long hashPerLine = 0L;
		try {
			BufferedReader in = new BufferedReader(new FileReader(fileName));
			Hash hash = new Hash();
			while ((str = in.readLine()) != null) {
				LineNum++;
				hashPerLine = hash.hashCode(str, false);
				System.out.println("Line:" +str);
				System.out.println("Hash value of Line::" +hashPerLine);
				fileHash += LineNum * hashPerLine;
			}
			in.close();
		} catch (Exception e) {
			e.printStackTrace();
			return -1L;
		}
		return fileHash;
	}*/

	// Added by cholia for pan check

	public static boolean checkPan(String pan) {
		pan = pan.toUpperCase();

		if ("PANINVALID".equalsIgnoreCase(pan)       
				|| "PANNOTAVBL".equalsIgnoreCase(pan)
				|| "PANAPPLIED".equalsIgnoreCase(pan) )
		{
			return false;
		} 
		else {
			if (pan.trim().length() != 10 || pan.length() != 10) {
				return true;
			}
			for (int i = 0; i < 3; i++) {
				if (!(pan.charAt(i) > 64 && pan.charAt(i) < 91)) {
					return true;
				}

			}

			for (int i = 5; i < 9; i++) {
				if (!(pan.charAt(i) > 47 && pan.charAt(i) < 58)) {
					return true;
				}
			}

			if (pan.charAt(3) != 'P' && pan.charAt(3) != 'H'
					&& pan.charAt(3) != 'C' && pan.charAt(3) != 'J'
					&& pan.charAt(3) != 'F' && pan.charAt(3) != 'A'
					&& pan.charAt(3) != 'T' && pan.charAt(3) != 'B'
					&& pan.charAt(3) != 'L' && pan.charAt(3) != 'G') {
				return true;
			}

			if (!(pan.charAt(4) > 64 && pan.charAt(4) < 91)) {
				return true;
			}

			if (!(pan.charAt(9) > 64 && pan.charAt(9) < 91)) {
				return true;
			}
	}
		return false;
	}
	
	
	//rahul CR84532 26Q Section Code Addition 194BA-P  4AP start
	public static boolean checkPanDedNoValues_PANAPPLIED(String pan, int rowTable, int colTable) {
		pan = pan.toUpperCase();
		
		if((GRPU.grpu.model1.getValueAt(rowTable,6).toString().contains("4BP") || GRPU.grpu.model1.getValueAt(rowTable,6).toString().contains("4RP") 
				|| GRPU.grpu.model1.getValueAt(rowTable,6).toString().contains("4SP")) 
				|| GRPU.grpu.model1.getValueAt(rowTable,6).toString().contains("4AP"))
		{
			if ("PANINVALID".equalsIgnoreCase(pan)       //rahul CR84532 26Q Section Code Addition 194BA-P  4AP
					|| "PANNOTAVBL".equalsIgnoreCase(pan)
					|| "PANAPPLIED".equalsIgnoreCase(pan) )
			{
				return true;
			} 
			
		}
		else
		{
			if ("PANINVALID".equalsIgnoreCase(pan)       //rahul CR84532 26Q Section Code Addition 194BA-P  4AP
					|| "PANNOTAVBL".equalsIgnoreCase(pan)
					|| "PANAPPLIED".equalsIgnoreCase(pan) )
			{
				return false;
			} 
		}
		
			if (pan.trim().length() != 10 || pan.length() != 10) {
				return true;
			}
			for (int i = 0; i < 3; i++) {
				if (!(pan.charAt(i) > 64 && pan.charAt(i) < 91)) {
					return true;
				}

			}

			for (int i = 5; i < 9; i++) {
				if (!(pan.charAt(i) > 47 && pan.charAt(i) < 58)) {
					return true;
				}
			}

			if (pan.charAt(3) != 'P' && pan.charAt(3) != 'H'
					&& pan.charAt(3) != 'C' && pan.charAt(3) != 'J'
					&& pan.charAt(3) != 'F' && pan.charAt(3) != 'A'
					&& pan.charAt(3) != 'T' && pan.charAt(3) != 'B'
					&& pan.charAt(3) != 'L' && pan.charAt(3) != 'G') {
				return true;
			}

			if (!(pan.charAt(4) > 64 && pan.charAt(4) < 91)) {
				return true;
			}

			if (!(pan.charAt(9) > 64 && pan.charAt(9) < 91)) {
				return true;
			}
			
		return false;
	}
	//rahul CR84532 26Q Section Code Addition 194BA-P  4AP end
	
	
	
	//Changes for CR82186 24Q start by Rahul for Adhaar validation
		public static boolean checkAdhar(String Adhar) {
		
				if (Adhar.trim().length() != 12 || Adhar.length() != 12) {
					return true;
				}
				
				for (int i = 0; i < 11; i++) {
					if (!(Adhar.charAt(i) > 47 && Adhar.charAt(i) < 58)) {
						return true;
					}
				}
	        return false;
		}
		

	public static boolean checkDedPan(String pan) {
		pan = pan.toUpperCase();
		if ("PANNOTREQD".equalsIgnoreCase(pan)) {
			return false;
		} else {
			if (pan.trim().length() != 10 || pan.length() != 10) {
				return true;
			}
			for (int i = 0; i < 3; i++) {
				if (!(pan.charAt(i) > 64 && pan.charAt(i) < 91)) {
					return true;
				}

			}

			for (int i = 5; i < 9; i++) {
				if (!(pan.charAt(i) > 47 && pan.charAt(i) < 58)) {
					return true;
				}
			}

			if (pan.charAt(3) != 'P' && pan.charAt(3) != 'H'
					&& pan.charAt(3) != 'C' && pan.charAt(3) != 'J'
					&& pan.charAt(3) != 'F' && pan.charAt(3) != 'A'
					&& pan.charAt(3) != 'T' && pan.charAt(3) != 'B'
					&& pan.charAt(3) != 'L' && pan.charAt(3) != 'G') {
				return true;
			}

			if (!(pan.charAt(4) > 64 && pan.charAt(4) < 91)) {
				return true;
			}

			if (!(pan.charAt(9) > 64 && pan.charAt(9) < 91)) {
				return true;
			}
		}
		return false;
	}

	// cholia end
	// cholia end

	/*public static boolean chkFileHash(File fileName) {
		long fileHash = 0L;
		String LngFileHash = "";
		boolean chkFile = false;
		long fileLength = 0L;
		String hashFromFile = "";
		String NameOfFile = fileName.getAbsolutePath();
		fileHash = getFileHash(NameOfFile);
		LngFileHash = String.valueOf(fileHash).trim();
		try {
			RandomAccessFile raf = new RandomAccessFile(fileName, "rw");
			fileLength = raf.length();
			raf.seek(fileLength - 21L);
			hashFromFile = raf.readLine();
			return hashFromFile.trim().equals(LngFileHash);
		} catch (Exception e) {
			return false;
		}
	}*/

/*	public static void hashSavedFile(String filepath) {
		try {
			RandomAccessFile raf;
			if (!filepath.endsWith(".grpu")) {
				filepath = filepath + ".grpu";
				raf = new RandomAccessFile(filepath, "rw");
			} else {
				raf = new RandomAccessFile(filepath, "rw");
			}
			long fileLength = 0L;
			long hashForLine = 0L;
			long LineNum = 0L;
			long S_fileHash = 0L;
			Hash hash = new Hash();
			for (String str = null; (str = raf.readLine()) != null;) {
				LineNum++;
				hashForLine = getHashofLine(str);
				S_fileHash += hashForLine;
			}

			fileLength = raf.length();
			raf.seek(fileLength);
			raf.writeBytes(hash.get20digitHashCode(S_fileHash));
			raf.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}*/

	/*public static boolean ReadHashFromImportedFile(String filepath) {
		try {
			//System.out.println(filepath);
			RandomAccessFile raf = new RandomAccessFile(filepath, "rw");
			long fileLength = 0L;
			long hashForLine = 0L;
			long LineNum = 0L;
			long S_fileHash = 0L;
			String hashOfFile = "";
			String CalculatedHash = "";
			Hash hash = new Hash();
			String getFileHeader = "";
			String HashofImportedFile = "";
			int posOfCarat = 0;
			String typOfHeader = "";
			int caretPos = 0;
			int nxtCaretPos = 0;
			int caretCount = 0;
			for (String str = null; (str = raf.readLine()) != null;) {
				LineNum++;
				caretPos = 0;
				nxtCaretPos = 0;
				caretPos = str.indexOf("^", caretPos + 1);
				nxtCaretPos = str.indexOf("^", caretPos + 1);
				typOfHeader = str.substring(caretPos + 1, nxtCaretPos);
				//System.out.println(typOfHeader);
				if (typOfHeader.equals("FH")) {
					caretPos = 0;
					nxtCaretPos = 0;
					for (caretCount = 0; caretCount != 9;) {
						caretCount++;
						caretPos = str.indexOf("^", caretPos + 1);
					}

					nxtCaretPos = str.indexOf("^", caretPos + 1);
					str = str.substring(0, caretPos + 1);
				} else {
					str = str.substring(0, str.lastIndexOf("^") + 1);
				}
				hashForLine = getHashofLine(str);
				S_fileHash += hashForLine * LineNum;
			}
			CalculatedHash = hash.get20digitHashCode(S_fileHash);
			raf.close();
			raf = new RandomAccessFile(filepath, "r");
			getFileHeader = raf.readLine();
			raf.close();
			posOfCarat = getFileHeader.lastIndexOf("^^^^");
			HashofImportedFile = getFileHeader.substring(posOfCarat - 20,
					posOfCarat);
		//	System.out.println(HashofImportedFile + "-------" + CalculatedHash);

			return HashofImportedFile.trim().equals(CalculatedHash.trim());
		} catch (Exception e) {
			return false;
		}
	}*/

	/*public static int ReadHashFromImportedFileNew(String filepath) {

		iErrCode = 0;
		try {
			File file = new File(filepath);
			if (file.exists() == false) {

				iErrCode = 1; // input file not found
				return iErrCode;
			}
			br = new BufferedReader(new FileReader(file));
			recStr = br.readLine();
		//	System.out.println(recStr + "  manish111");
			if (recStr == null || recStr.length() == 0) {
				iErrCode = 2; // empty record found
				return iErrCode;
			}

			tokenizeFileHeader(recStr);
			// processFVU();

		} catch (Exception e) {

			iErrCode = 12; // unknown error. exception occured.
			Log.tbaf_log.error("Exception", e);
			e.printStackTrace();
		} finally {
			try {
				if (br != null)
					br.close();
			} catch (IOException e1) {
				Log.tbaf_log.error("Exception", e1);
				e1.printStackTrace();
			}
		}
	//	System.out.println(iErrCode);
		return iErrCode;
	}*/

	public static long hashCode(String recStr, boolean includeCaret) {
		long hc = 0;
		int i = 0;
		for (; i < recStr.length(); i++) {
			hc += (((int) recStr.charAt(i)) * (i + 1));
		}
		if (includeCaret == true)
			hc += ((i + 1) * ((int) '^'));
		System.out.println("Hash value of Line:" + hc);
		return hc;
	}

	/*public static boolean ReadHashFromOpenFile(String filepath) {
		try {
			RandomAccessFile raf = new RandomAccessFile(filepath, "rw");
			long fileLength = 0L;
			long hashForLine = 0L;
			long LineNum = 0L;
			long S_fileHash = 0L;
			String hashOfFile = "";
			String CalculatedHash = "";
			Hash hash = new Hash();
			for (String str = null; (str = raf.readLine()) != null;)
				if (str.length() > 20) {
					LineNum++;
					hashForLine = getHashofLine(str);
					S_fileHash += hashForLine;
				}

			CalculatedHash = hash.get20digitHashCode(S_fileHash);
			fileLength = raf.length();
			raf.seek(fileLength - 20L);
			hashOfFile = raf.readLine();
			raf.close();
			return hashOfFile.trim().equals(CalculatedHash.trim());
		} catch (Exception e) {
			return false;
		}
	}*/

	// changed by cholia for the challan
	public static int[] getFilledRows(DefaultTableModel model) {
	//	System.out.println("inside getFilledRows");
		int arrayRow[] = new int[model.getRowCount()];
		int count = 0;

		Object obj = null;
		for (int i = 0; i < arrayRow.length; i++)
			arrayRow[i] = -1;

		for (int i = 2; i < model.getRowCount(); i++) {
			for (int col = 1; col < GRPU.TABLE_COLUMN_COUNT_challan - 1; col++) {
				obj = model.getValueAt(i, col); // yahn pe fat raha hai model ki
				// length k karan

				if (col == 1 || col == 2 || col == 18 || col == 21) {
					if (obj==null || "--Select--".equals(obj.toString().trim()))
						continue;
					// arrayRow[i] = i;
					// break;
				}

				if (obj == null || obj.toString().equals(""))
					continue;

				else {
					arrayRow[i] = i;
					count++;
					break;

				}
			}

		}
		//System.out.println("array length is" + arrayRow.length);
		//System.out.println("filled rows are " + count);
		return arrayRow;
	}

	// Added by Akansha
	// New method depending upon the selected form number AnnexureI
	public static int[] getFilledRowsAnnI(DefaultTableModel model,
			int columncount) {
	//	System.out.println("inside getFilledRows");
		int arrayRow[] = new int[model.getRowCount()];
		int count = 0;

		Object obj = null;
		for (int i = 0; i < arrayRow.length; i++)
			arrayRow[i] = -1;

		for (int i = 2; i < model.getRowCount(); i++) {
			for (int col = 1; col < columncount; col++) {
				obj = model.getValueAt(i, col);

				if (col == 1 || col == 2 || col == 6 || col == 26) {
					if (obj.toString().trim().equals("--Select--"))
						continue;
					// arrayRow[i] = i;
					// break;
				}

				if (obj == null || obj.toString().equals(""))
					continue;

				else {
					arrayRow[i] = i;
					count++;
					break;

				}

			}

		}
		System.out.println("array length is" + arrayRow.length);
		System.out.println("filled rows are " + count);
		return arrayRow;
	}

	// Added by Akansha
	// New method depending upon the selected form number for AnnexureII
	public static int[] getFilledRowsAnnII(DefaultTableModel model,
			int columncount) {
	//	System.out.println("inside getFilledRows");
		int arrayRow[] = null;
		if (model != null) {
			arrayRow = new int[model.getRowCount()];
			int count = 0;

			Object obj = null;
			for (int i = 0; i < arrayRow.length; i++)
				arrayRow[i] = -1;

			for (int i = 2; i < model.getRowCount(); i++) {
				for (int col = 2; col <= columncount; col++) {
					obj = model.getValueAt(i, col);

					if (col == 2 || col == 5 || col == 32) {
						if (obj.toString().trim().equals("--Select--"))
							continue;
						// arrayRow[i] = i;
						// break;
					}

					if (obj == null || obj.toString().equals(""))
						continue;

					else {
						arrayRow[i] = i;
						count++;
						break;

					}

				}

			}
			//System.out.println("array length is" + arrayRow.length);
		//	System.out.println("filled rows are " + count);
		}
		return arrayRow;
	}
	
	public static int[] getFilledRowsAnnIII(DefaultTableModel model,  //Changes for CR82186 SaveFile for AnnexureIII
			int columncount) {
	//	System.out.println("inside getFilledRows");
		int arrayRow[] = null;
		if (model != null) {
			arrayRow = new int[model.getRowCount()];
			int count = 0;

			Object obj = null;
			for (int i = 0; i < arrayRow.length; i++)
				arrayRow[i] = -1;

			for (int i = 2; i < model.getRowCount(); i++) {
				for (int col = 2; col <= columncount; col++) {
					obj = model.getValueAt(i, col);

					if (col == 2 || col == 5 || col == 32) {
						if (obj.toString().trim().equals("--Select--"))
							continue;
						// arrayRow[i] = i;
						// break;
					}

					if (obj == null || obj.toString().equals(""))
						continue;

					else {
						arrayRow[i] = i;
						count++;
						break;

					}

				}

			}
			
		}
		return arrayRow;
	}

	public static boolean isIn_DDO_REG_NO_MOD(String midDigit, String lastDigit) {
		if (lastDigit == null || lastDigit.trim().length() == 0) {
			return false;
		}
		int modSeven = Integer.parseInt(midDigit) % 7;
		for (int i = 0; i < DDO_REG_NO_MOD.length; i++) {
			if (DDO_REG_NO_MOD[i].equals(lastDigit)) {
				if (i == modSeven) {
					return true;
				}
			}
		}
		return false;
	}

	public static void getMessageDlg(String message) {
		JOptionPane.showMessageDialog(JdialogFrame, message);
	}

	public static String replaceFirst(String baseStr, String subStrOfBaseStr,
			String repalcement) {
		String subStr_begin = "";
		String subStr_middle = "";
		String subStr_end = "";
		String newStr = "";
		if (baseStr.indexOf(subStrOfBaseStr) >= 0) {
			int pos = baseStr.indexOf(subStrOfBaseStr);
			int last_pos = pos + subStrOfBaseStr.length();
			subStr_begin = baseStr.substring(0, pos);
			subStr_middle = repalcement;
			subStr_end = baseStr.substring(last_pos, baseStr.length());
			newStr = subStr_begin + subStr_middle + subStr_end;
			return newStr;
		} else {
			return baseStr;
		}
	}

	static {
		htStateCodeName = new Hashtable();
		htQuarter = new Hashtable();
		htFinYear = new Hashtable();
		htStateNameCode = new Hashtable();
		ministryNameCode = new Hashtable();
		subMinistryNameCode = new Hashtable();
		ministryCodeName = new Hashtable();
		subMinistryCodeName = new Hashtable();
		htAddressChange = new Hashtable();
		httypeOfDeductor = new Hashtable();
		httypeOfDeductorCode = new Hashtable();
		employeeTypeCode = new Hashtable();
		Annex3employeeTypeCode = new Hashtable();//Changes for CR82186 Create file .txt Regular for AnnexureIII
		updationmode = new Hashtable();
		htremittanceCode = new Hashtable();
		htremittanceCodeReverse = new Hashtable();
		htCountryCode = new Hashtable();
		htCountryCodeReverse = new Hashtable();
		htDDtypeAnnII = new Hashtable();
		htDDtypeAnnIII = new Hashtable(); //By Prajakta

		htStateCodeName.put("01", "Andaman & Nicobar Islands");
		htStateCodeName.put("02", "Andhra Pradesh");
		htStateCodeName.put("03", "Arunachal Pradesh");
		htStateCodeName.put("04", "Assam");
		htStateCodeName.put("05", "Bihar");
		htStateCodeName.put("06", "Chandigarh");
		htStateCodeName.put("07", "Dadra Nagar Haveli & Daman Diu");
		//htStateCodeName.put("08", "Daman & Diu");
		htStateCodeName.put("09", "Delhi");
		htStateCodeName.put("10", "Goa");
		htStateCodeName.put("11", "Gujarat");
		htStateCodeName.put("12", "Haryana");
		htStateCodeName.put("13", "Himachal Pradesh");
		htStateCodeName.put("14", "Jammu & Kashmir");
		htStateCodeName.put("15", "Karnataka");
		htStateCodeName.put("16", "Kerala");
		htStateCodeName.put("17", "Lakshwadeep");
		htStateCodeName.put("18", "Madhya Pradesh");
		htStateCodeName.put("19", "Maharashtra");
		htStateCodeName.put("20", "Manipur");
		htStateCodeName.put("21", "Meghalaya");
		htStateCodeName.put("22", "Mizoram");
		htStateCodeName.put("23", "Nagaland");
		htStateCodeName.put("24", "Odisha");
		htStateCodeName.put("25", "Pondicherry");
		htStateCodeName.put("26", "Punjab");
		htStateCodeName.put("27", "Rajasthan");
		htStateCodeName.put("28", "Sikkim");
		htStateCodeName.put("29", "Tamil Nadu");
		htStateCodeName.put("30", "Tripura");
		htStateCodeName.put("31", "Uttar Pradesh");
		htStateCodeName.put("32", "West Bengal");
		htStateCodeName.put("33", "Chhattisgarh");
		htStateCodeName.put("34", "Uttarakhand");
		htStateCodeName.put("35", "Jharkhand");
		htStateCodeName.put("36", "Telangana");
		//added for Ladakh
		htStateCodeName.put("37", "Ladakh");
		htStateNameCode.put("ANDAMAN & NICOBAR ISLANDS", "01");
		htStateNameCode.put("ANDHRA PRADESH", "02");
		htStateNameCode.put("ARUNACHAL PRADESH", "03");
		htStateNameCode.put("ASSAM", "04");
		htStateNameCode.put("BIHAR", "05");
		htStateNameCode.put("CHANDIGARH", "06");
		htStateNameCode.put("DADRA NAGAR HAVELI & DAMAN DIU", "07");
		//htStateNameCode.put("DAMAN & DIU", "08");
		htStateNameCode.put("DELHI", "09");
		htStateNameCode.put("GOA", "10");
		htStateNameCode.put("GUJARAT", "11");
		htStateNameCode.put("HARYANA", "12");
		htStateNameCode.put("HIMACHAL PRADESH", "13");
		htStateNameCode.put("JAMMU & KASHMIR", "14");
		htStateNameCode.put("KARNATAKA", "15");
		htStateNameCode.put("KERALA", "16");
		htStateNameCode.put("LAKSHWADEEP", "17");
		htStateNameCode.put("MADHYA PRADESH", "18");
		htStateNameCode.put("MAHARASHTRA", "19");
		htStateNameCode.put("MANIPUR", "20");
		htStateNameCode.put("MEGHALAYA", "21");
		htStateNameCode.put("MIZORAM", "22");
		htStateNameCode.put("NAGALAND", "23");
		htStateNameCode.put("ODISHA", "24");
		htStateNameCode.put("PONDICHERRY", "25");
		htStateNameCode.put("PUNJAB", "26");
		htStateNameCode.put("RAJASTHAN", "27");
		htStateNameCode.put("SIKKIM", "28");
		htStateNameCode.put("TAMIL NADU", "29");
		htStateNameCode.put("TRIPURA", "30");
		htStateNameCode.put("UTTAR PRADESH", "31");
		htStateNameCode.put("WEST BENGAL", "32");
		htStateNameCode.put("CHHATTISGARH", "33");
		htStateNameCode.put("UTTARAKHAND", "34");
		htStateNameCode.put("JHARKHAND", "35");
		htStateNameCode.put("TELANGANA", "36");
		//added for ladakh
		htStateNameCode.put("LADAKH", "37");
		ministryNameCode.put("Civil", "01");
		ministryNameCode.put("Railway", "02");
		ministryNameCode.put("Defence", "03");
		ministryNameCode.put("Telecommunication", "04");
		ministryNameCode.put("Post", "05");

		subMinistryNameCode.put("Agriculture", "01");
		subMinistryNameCode.put("Atomic Energy", "02");
		subMinistryNameCode.put("Fertilizers", "03");
		subMinistryNameCode.put("Chemicals and Petrochemicals", "04");
		subMinistryNameCode.put("Civil Aviation and Tourism", "05");
		subMinistryNameCode.put("Coal", "06");
		subMinistryNameCode.put(
				"Consumer Affairs, Food and Public Distribution", "07");
		subMinistryNameCode.put("Commerce and Textiles", "08");
		subMinistryNameCode.put(
				"Environment and Forests and Ministry of Earth Science", "09");
		subMinistryNameCode.put("External Affairs and Overseas Indian Affairs",
				"10");
		subMinistryNameCode.put("Finance", "11");
		subMinistryNameCode.put("Central Board of Direct Taxes", "12");
		subMinistryNameCode.put("Central Board of Excise and Customs", "13");
		subMinistryNameCode.put("Controller of Aid Accounts and Audit", "14");
		subMinistryNameCode.put("Central Pension Accounting Office", "15");
		subMinistryNameCode.put("Food Processing Industries", "16");
		subMinistryNameCode.put("Health and Family Welfare", "17");
		subMinistryNameCode.put("Home Affairs and Development of North Eastern Region", "18");
		subMinistryNameCode.put("Human Resource Development", "19");
		subMinistryNameCode.put("Industry", "20");
		subMinistryNameCode.put("Information and Broadcasting", "21");
		subMinistryNameCode.put("Telecommunication and Information Technology",
				"22");
		subMinistryNameCode.put("Labour", "23");
		subMinistryNameCode.put("Law and Justice and Company Affairs", "24");
		subMinistryNameCode.put("Personnel, Public Grievances and Pensions",
				"25");
		subMinistryNameCode.put("Petroleum and Natural Gas", "26");
		subMinistryNameCode.put(
				"Plannning, Statistics and Programme Implementation", "27");
		subMinistryNameCode.put("Power", "28");
		subMinistryNameCode.put("New and Renewable Energy", "29");
		subMinistryNameCode.put("Rural Development and Panchayati Raj", "30");
		subMinistryNameCode.put("Science And Technology", "31");
		subMinistryNameCode.put("Space", "32");
		subMinistryNameCode.put("Steel", "33");
		subMinistryNameCode.put("Mines", "34");
		subMinistryNameCode.put("Social Justice and Empowerment", "35");
		subMinistryNameCode.put("Tribal Affairs", "36");
		subMinistryNameCode.put("D/o of Commerce (Supply Division)", "37");
		subMinistryNameCode.put("Shipping and Road Transport and Highways",
				"38");
		subMinistryNameCode.put(
				"Urban Development, Urban Employment and Poverty Alleviation",
				"39");
		subMinistryNameCode.put("Water Resources", "40");
		subMinistryNameCode.put("President's Secretariat", "41");
		subMinistryNameCode.put("Lok Sabha Secretariat", "42");
		subMinistryNameCode.put("Rajya Sabha secretariat", "43");
		subMinistryNameCode.put("Election Commission", "44");
		subMinistryNameCode.put(
				"Ministry of Defence (Controller General of Defence Accounts)",
				"45");
		subMinistryNameCode.put("Ministry of Railways", "46");
		subMinistryNameCode.put("Department of Posts", "47");
		subMinistryNameCode.put("Department of Telecommunications", "48");
		subMinistryNameCode.put("Andaman and Nicobar Islands Administration",
				"49");
		subMinistryNameCode.put("Chandigarh Administration", "50");
		subMinistryNameCode.put("Dadra and Nagar Haveli", "51");
		subMinistryNameCode.put("Goa, Daman and Diu", "52");
		subMinistryNameCode.put("Lakshadweep", "53");
		subMinistryNameCode.put("Pondicherry Administration", "54");
		subMinistryNameCode.put("Pay and Accounts Officers (Audit)", "55");
		subMinistryNameCode.put("Ministry of Non-conventional energy sources",
				"56");
		subMinistryNameCode.put("Government Of NCT of Delhi", "57");
		subMinistryNameCode.put("Others", "99");

		ministryCodeName.put("01", "Civil");
		ministryCodeName.put("02", "Railway");
		ministryCodeName.put("03", "Defence");
		ministryCodeName.put("04", "Telecommunication");
		ministryCodeName.put("05", "Post");

		subMinistryCodeName.put("01", "Agriculture");
		subMinistryCodeName.put("02", "Atomic Energy");
		subMinistryCodeName.put("03", "Fertilizers");
		subMinistryCodeName.put("04", "Chemicals and Petrochemicals");
		subMinistryCodeName.put("05", "Civil Aviation and Tourism");
		subMinistryCodeName.put("06", "Coal");
		subMinistryCodeName.put("07",
				"Consumer Affairs, Food and Public Distribution");
		subMinistryCodeName.put("08", "Commerce and Textiles");
		subMinistryCodeName.put("09",
				"Environment and Forests and Ministry of Earth Science");
		subMinistryCodeName.put("10",
				"External Affairs and Overseas Indian Affairs");
		subMinistryCodeName.put("11", "Finance");
		subMinistryCodeName.put("12", "Central Board of Direct Taxes");
		subMinistryCodeName.put("13", "Central Board of Excise and Customs");
		subMinistryCodeName.put("14", "Controller of Aid Accounts and Audit");
		subMinistryCodeName.put("15", "Central Pension Accounting Office");
		subMinistryCodeName.put("16", "Food Processing Industries");
		subMinistryCodeName.put("17", "Health and Family Welfare");
		subMinistryCodeName.put("18",
				"Home Affairs and Development of North Eastern Region");
		subMinistryCodeName.put("19", "Human Resource Development");
		subMinistryCodeName.put("20", "Industry");
		subMinistryCodeName.put("21", "Information and Broadcasting");
		subMinistryCodeName.put("22",
				"Telecommunication and Information Technology");
		subMinistryCodeName.put("23", "Labour");
		subMinistryCodeName.put("24", "Law and Justice and Company Affairs");
		subMinistryCodeName.put("25",
				"Personnel, Public Grievances and Pensions");
		subMinistryCodeName.put("26", "Petroleum and Natural Gas");
		subMinistryCodeName.put("27",
				"Plannning, Statistics and Programme Implementation");
		subMinistryCodeName.put("28", "Power");
		subMinistryCodeName.put("29", "New and Renewable Energy");
		subMinistryCodeName.put("30", "Rural Development and Panchayati Raj");
		subMinistryCodeName.put("31", "Science And Technology");
		subMinistryCodeName.put("32", "Space");
		subMinistryCodeName.put("33", "Steel");
		subMinistryCodeName.put("34", "Mines");
		subMinistryCodeName.put("35", "Social Justice and Empowerment");
		subMinistryCodeName.put("36", "Tribal Affairs");
		subMinistryCodeName.put("37", "D/o of Commerce (Supply Division)");
		subMinistryCodeName.put("38",
				"Shipping and Road Transport and Highways");
		subMinistryCodeName.put("39",
				"Urban Development, Urban Employment and Poverty Alleviation");
		subMinistryCodeName.put("40", "Water Resources");
		subMinistryCodeName.put("41", "President's Secretariat");
		subMinistryCodeName.put("42", "Lok Sabha Secretariat");
		subMinistryCodeName.put("43", "Rajya Sabha Secretariat");
		subMinistryCodeName.put("44", "Election Commission");
		subMinistryCodeName.put(
				"Ministry of Defence (Controller General of Defence Accounts)",
				"45");
		subMinistryCodeName.put("46", "Ministry of Railways");
		subMinistryCodeName.put("47", "Department of Posts");
		subMinistryCodeName.put("48", "Department of Telecommunications");
		subMinistryCodeName.put("49",
				"Andaman and Nicobar Islands Administration");
		subMinistryCodeName.put("50", "Chandigarh Administration");
		subMinistryCodeName.put("51", "Dadra and Nagar Haveli");
		subMinistryCodeName.put("52", "Goa, Daman and Diu");
		subMinistryCodeName.put("53", "Lakshadweep");
		subMinistryCodeName.put("54", "Pondicherry Administration");
		subMinistryCodeName.put("55", "Pay and Accounts Officers (Audit)");
		subMinistryCodeName.put("56",
				"Ministry of Non-conventional energy sources");
		subMinistryCodeName.put("57", "Government Of NCT of Delhi");
		subMinistryCodeName.put("99", "Others");
		// Addition of financial years to hash table for later retrieval
		// during open of saved correction/regular file added by Akansha
		htFinYear.put("200708", "2007-2008");
		htFinYear.put("200809", "2008-2009");
		htFinYear.put("200910", "2009-2010");
		htFinYear.put("201011", "2010-2011");
		htFinYear.put("201112", "2011-2012");
		htFinYear.put("201213", "2012-2013");
		htFinYear.put("201314", "2013-2014");
		//

		// Quarter addition added by Akansha
		htQuarter.put("Q1", "Q1");
		htQuarter.put("Q2", "Q2");
		htQuarter.put("Q3", "Q3");
		htQuarter.put("Q4", "Q4");

		// Option of Yes or No for isAddressChange, isRevised and hasReturned
		// fields of the form
		htAddressChange.put("Y", "Yes");
		htAddressChange.put("N", "No");
		// ************************************************************

		// Added by Akansha

		httypeOfDeductor.put("A", "Central Government");
		httypeOfDeductor.put("S", "State Government");
		httypeOfDeductor.put("D", "Statutory body (Central Govt.)");
		httypeOfDeductor.put("E", "Statutory body (State Govt.)");
		httypeOfDeductor.put("G", "Autonomous body (Central Govt.)");
		httypeOfDeductor.put("H", "Autonomous body (State Govt.)");
		httypeOfDeductor.put("L", "Local Authority (Central Govt.)");
		httypeOfDeductor.put("N", "Local Authority (State Govt.)");
		httypeOfDeductor.put("K", "Company");
		httypeOfDeductor.put("M", "Branch / Division of Company");
		httypeOfDeductor.put("P", "Association of Person (AOP)");
		httypeOfDeductor.put("T", "Association of Person (Trust)");
		httypeOfDeductor.put("J", "Artificial Juridical Person");
		httypeOfDeductor.put("B", "Body of Individuals");
		httypeOfDeductor.put("Q", "Individual/HUF");
		httypeOfDeductor.put("F", "Firm");

		// ****************************************************

		// Code added for employee type
		employeeTypeCode.put("Women", "W");
		employeeTypeCode.put("Senior Citizen", "S");
		employeeTypeCode.put("Super Senior Citizen", "O");
		employeeTypeCode.put("Others", "G");
		// ***************************
		Annex3employeeTypeCode.put("Super Senior Citizen", "O"); //Changes for CR82186 Create file .txt Regular for AnnexureIII
		Annex3employeeTypeCode.put("Senior Citizen", "S");  //Changes for CR82186 Create file .txt Regular for AnnexureIII

		// Added by Akansha
		htDDtypeAnnII.put("W", "Women");
		htDDtypeAnnII.put("S", "Senior Citizen");
		htDDtypeAnnII.put("O", "Super Senior Citizen");
		htDDtypeAnnII.put("G", "Others");

		// *****************************
		//Changes By Prajakta
		htDDtypeAnnIII.put("S", "Senior Citizen");
		htDDtypeAnnIII.put("O", "Super Senior Citizen");
		//*********************************

		// Code for type of modes
		updationmode.put("ADD", "A");
		updationmode.put("UPDATE", "U");
		updationmode.put("DELETE", "D");
		updationmode.put("PAN UPDATE", "");
		// ****************************************************

		// **************Added by Akansha -- For Deductor code **************

		httypeOfDeductorCode.put("Central Government", "A");
		httypeOfDeductorCode.put("State Government", "S");
		httypeOfDeductorCode.put("Statutory body (Central Govt.)", "D");
		httypeOfDeductorCode.put("Statutory body (State Govt.)", "E");
		httypeOfDeductorCode.put("Autonomous body (Central Govt.)", "G");
		httypeOfDeductorCode.put("Autonomous body (State Govt.)", "H");
		httypeOfDeductorCode.put("Local Authority (Central Govt.)", "L");
		httypeOfDeductorCode.put("Local Authority (State Govt.)", "N");
		httypeOfDeductorCode.put("Company", "K");
		httypeOfDeductorCode.put("Branch / Division of Company", "M");
		httypeOfDeductorCode.put("Association of Person (AOP)", "P");
		httypeOfDeductorCode.put("Association of Person (Trust)", "T");
		httypeOfDeductorCode.put("Artificial Juridical Person", "J");
		httypeOfDeductorCode.put("Body of Individuals", "B");
		httypeOfDeductorCode.put("Individual/HUF", "Q");
		httypeOfDeductorCode.put("Firm", "F");
		// Added by Priya remittance code 11, 27, 37, 63, 64, 21, 49, 16, 28, 31, 52 & 99
		// Newly added for Development as on 01/04/2015
		
		//New development for FRD1.3 by Akansha
		//htremittanceCode.put("11", "COMMISSION");
		htremittanceCode.put("27", "INTEREST PAYMENT");
		//new development for FRD1.3 by Akansha
//		htremittanceCode.put("37", "PAYMENTS TO SPORTS PERSON & ARTISTS");
//		htremittanceCode.put("63", "WINNING FROM HORSE RACES.");
//		htremittanceCode.put("64","WINNING FROM LOTTERIES, CROSSWORD PUZZLES, CARD GAMES AND OTHER GAMES OF ANY SORT.");
		htremittanceCode.put("21",
				"FEES FOR TECHNICAL SERVICES/ FEES FOR INCLUDED SERVICES");
		htremittanceCode.put("49", "ROYALTY");
		htremittanceCode.put("16", "DIVIDEND");
		htremittanceCode.put("28", "INVESTMENT INCOME");
		htremittanceCode.put("31", "LONG TERM CAPITAL GAINS (Others)");//rahul CR84532 27Q nature of remmittance 
		htremittanceCode.put("52", "SHORT TERM CAPITAL GAINS");
		htremittanceCode.put("99","OTHER INCOME / OTHER (NOT IN THE NATURE OF INCOME)");
		htremittanceCode.put("66", "LONG TERM CAPITAL GAIN u/s 115E IN CASE OF NON RESIDENT INDIAN CITIZEN");//rahul CR84532 27Q nature of remmittance 
		htremittanceCode.put("67", "LONG TERM CAPITAL GAIN u/s 112(1)(c)(iii)");//rahul CR84532 27Q nature of remmittance 
		htremittanceCode.put("68", "LONG TERM CAPITAL GAIN u/s 112");//rahul CR84532 27Q nature of remmittance 
		htremittanceCode.put("69", "LONG TERM CAPITAL GAIN u/s 112A");//rahul CR84532 27Q nature of remmittance 
		htremittanceCode.put("70", "SHORT TERM CAPITAL GAIN u/s 111A");//rahul CR84532 27Q nature of remmittance 
		
		//***********************************************
/*		htremittanceCode.put("1", "ADVERTISEMENT FEE");
		htremittanceCode.put("2", "AMC CHARGES");
		htremittanceCode.put("3", "ARCHITECTURAL SERVICES");
		htremittanceCode.put("4", "BANDWIDTH CHARGES");
		htremittanceCode.put("5", "BROKEREAGE CHARGES");
		htremittanceCode.put("6",
				"BUSINESS INCOME OTHER THAN THAT COVERED BY CATEGORIES ABOVE ");
		htremittanceCode.put("7",
				"CARGO HANDLING SERVICES INSPECTION & LOGISTICS SERVICES");
		htremittanceCode.put("8", "CELLULAR ROAMING CHARGES");
		htremittanceCode.put("9", "CHARTER HIRE CHARGES (SHIPPING)");
		htremittanceCode.put("10", "CLEARING & FORWARDING CHARGES");

		htremittanceCode.put("11", "COMMISSION");
		htremittanceCode.put("12", "COMMUNICATION CHARGES");
		htremittanceCode.put("13", "CONSULTING SERVICES ");
		htremittanceCode.put("14", "DESIGNING FEE");
		htremittanceCode.put("15", "DIRECTORS FEES");
		htremittanceCode.put("16", "DIVIDEND ");
		htremittanceCode.put("17", "DRILLING");
		htremittanceCode.put("18", "ENGINEERING SERVICES");
		htremittanceCode.put("19", "EQUIPMENT RENTAL CHARGES");
		htremittanceCode.put("20", "FABRICATION SERVICES ");

		htremittanceCode.put("21",
				"FEES FOR TECHNICAL SERVICES/ FEES FOR INCLUDED SERVICES");
		htremittanceCode.put("22", "FREIGHT CHARGES");
		htremittanceCode.put("23", "INCOME FROM IMMOVEABLE PROPERTY ");
		htremittanceCode.put("24",
				"INCOME FROM SHIPPING, INLAND WATERWAYS OR AIR TRANSPORT");
		htremittanceCode.put("25", "INSTALLATION & COMMISSIONING SERVICES");
		htremittanceCode.put("26", "INSURANCE COMMISSIONS ");
		htremittanceCode.put("27", "INTEREST PAYMENT");
		htremittanceCode.put("28", "INVESTMENT INCOME");
		htremittanceCode.put("29", "LEASE PAYMENT");
		htremittanceCode.put("30", "LICENSING FEE");

		htremittanceCode.put("31", "LONG TERM CAPITAL GAINS");
		htremittanceCode.put("32", "MEMBERSHIP FEE");
		htremittanceCode.put("33", "MOBILESTATION CHARGES");
		htremittanceCode.put("34",
				"PAYMENTS FOR SOFTWARE BUNDLED WITH HARDWARE");
		htremittanceCode.put("35",
				"PAYMENTS FOR SOFTWARE BUNDLED WITH HARDWARE");
		htremittanceCode.put("36",
				"PAYMENTS TO PROFESSORS, TEACHERS OR RESEARCH SCHOLARS");
		htremittanceCode.put("37", "PAYMENTS TO SPORTS PERSON & ARTISTS");
		htremittanceCode.put("38",
				"PAYMENTS TO STUDENTS OR BUSINESS APPRENTICE");
		htremittanceCode.put("39",
				"PENSIONS(OTHER THAN THOSE RELATED TO PAST EMPLOYMENT)");
		htremittanceCode.put("40", "PROCESSING CHARGES");

		htremittanceCode.put("41", "PROFESSIONAL SERVICES");
		htremittanceCode.put("42", "PURCHASE OF SOFTWARE");
		htremittanceCode.put("43", "R&D CHARGES");
		htremittanceCode.put("44", "REGISTRATION CHARGES");
		htremittanceCode.put("45", "REIMBURSEMENT OF EXPENSES");
		htremittanceCode.put("46", "REPATRIATION OF SURPLUS FUNDS");
		htremittanceCode.put("47", "RETAINERSHIP FEES");
		htremittanceCode.put("48", "RETENTION FEES");
		htremittanceCode.put("49", "ROYALTY");
		htremittanceCode.put("50", "SALES AND MARKETING SERVICES");

		htremittanceCode.put("51", "SEISMIC DATA PROCESSING");
		htremittanceCode.put("52", "SHORT TERM CAPITAL GAINS");
		htremittanceCode.put("53", "SOFTWARE LICENCES");
		htremittanceCode.put("54", "SPONSORSHIP FEES");
		htremittanceCode.put("55", "SUBSCRIPTION FEES");
		htremittanceCode.put("56", "SUPERVISION CHARGES");
		htremittanceCode.put("57", "SURVEY FEES");
		htremittanceCode.put("58", "TELECASTING SERVICES");
		htremittanceCode.put("59", "TENDER FEES");
		htremittanceCode.put("60", "TESTING CHARGES");

		htremittanceCode.put("61", "TRAINING");
		htremittanceCode.put("62", "WARRANTY SERVICES");
		htremittanceCode.put("63", "WINNING FROM HORSE RACES.");
		htremittanceCode
				.put(
						"64",
						"WINNING FROM LOTTERIES, CROSSWORD PUZZLES, CARD GAMES AND OTHER GAMES OF ANY SORT.");
		htremittanceCode.put("65", " CONSULAR RECEIPTS");
		htremittanceCode.put("99",
				"OTHER INCOME / OTHER (NOT IN THE NATURE OF INCOME)");
*/
		
		// *********************************************************

		// Added by Priya country code
		htCountryCode.put("01", "AFGHANISTAN");
		htCountryCode.put("02", "AKROTIRI");
		htCountryCode.put("03", "ALBANIA");
		htCountryCode.put("04", "ALGERIA");
		htCountryCode.put("05", "AMERICAN SAMOA");
		htCountryCode.put("06", "ANDORRA");
		htCountryCode.put("07", "ANGOLA");
		htCountryCode.put("08", "ANGUILLA");
		htCountryCode.put("09", "ANTARCTICA");
		htCountryCode.put("1", "AFGHANISTAN");
		htCountryCode.put("2", "AKROTIRI");
		htCountryCode.put("3", "ALBANIA");
		htCountryCode.put("4", "ALGERIA");
		htCountryCode.put("5", "AMERICAN SAMOA");
		htCountryCode.put("6", "ANDORRA");
		htCountryCode.put("7", "ANGOLA");
		htCountryCode.put("8", "ANGUILLA");
		htCountryCode.put("9", "ANTARCTICA");
		htCountryCode.put("10", "ANTIGUA AND BARBUDA");

		htCountryCode.put("11", "ARGENTINA");
		htCountryCode.put("12", "ARMENIA");
		htCountryCode.put("13", "ARUBA");
		htCountryCode.put("14", "ASHMORE AND CARTIER ISLANDS");
		htCountryCode.put("15", "AUSTRALIA");
		htCountryCode.put("16", "AUSTRIA");
		htCountryCode.put("17", "AZERBAIJAN");
		htCountryCode.put("18", "BAHRAIN");
		htCountryCode.put("19", "BAILIWICK OF GUERNSEY");
		htCountryCode.put("20", "BAILIWICK OF JERSEY");

		htCountryCode.put("21", "BAKER ISLAND");
		htCountryCode.put("22", "BANGLADESH");
		htCountryCode.put("23", "BARBADOS");
		htCountryCode.put("24", "BELARUS");
		htCountryCode.put("25", "BELGIUM");
		htCountryCode.put("26", "BELIZE");
		htCountryCode.put("27", "BENIN PORTO");
		htCountryCode.put("28", "BERMUDA");
		htCountryCode.put("29", "BHUTAN");
		htCountryCode.put("30", "BOLIVIA");

		htCountryCode.put("31", "BOSNIAAND HERZEGOVINA");
		htCountryCode.put("32", "BOTSWANA");
		htCountryCode.put("33", "BOUVET ISLAND");
		htCountryCode.put("34", "BRAZIL");
		htCountryCode.put("35", "BRITISH INDIAN OCEAN TERRITORY");
		htCountryCode.put("36", "BRUNEI");
		htCountryCode.put("37", "BULGARIA");
		htCountryCode.put("38", "BURKINA FASO");
		htCountryCode.put("39", "BURUNDI");
		htCountryCode.put("40", "CAMBODIA");

		htCountryCode.put("41", "CAMEROON");
		htCountryCode.put("42", "CANADA");
		htCountryCode.put("43", "CAPE VERDE");
		htCountryCode.put("44", "CAYMAN ISLANDS");
		htCountryCode.put("45", "CENTRAL AFRICAN REPUBLIC");
		htCountryCode.put("46", "CHAD");
		htCountryCode.put("47", "CHILE");
		htCountryCode.put("48", "CHINA");
		htCountryCode.put("49", "CHRISTMAS ISLAND");
		htCountryCode.put("50", "CLIPPERTON ISLAND");

		htCountryCode.put("51", "COCOS (KEELING) ISLANDS");
		htCountryCode.put("52", "COLOMBIA");
		htCountryCode.put("53", "COMMONWEALTH OF PUERTO RICO");
		htCountryCode.put("54", "COMMONWEALTH OF THE NORTHERN MARIANA ISLANDS");
		htCountryCode.put("55", "COMOROS");
		htCountryCode.put("56", "CONGO,DEMOCRATIC REPUBLIC OF THE");
		htCountryCode.put("57", "CONGO,REPUBLIC OF THE");
		htCountryCode.put("58", "COOK ISLANDS");
		htCountryCode.put("59", "CORAL SEA ISLANDS");
		htCountryCode.put("60", "CORAL SEA ISLANDS TERRITORY");

		htCountryCode.put("61", "COSTA RICA");
		htCountryCode.put("62", "COTE D'IVOIRE");
		htCountryCode.put("63", "CROATIA");
		htCountryCode.put("64", "CUBA");
		htCountryCode.put("65", "CYPRUS");
		htCountryCode.put("66", "CZECH REPUBLIC");
		htCountryCode.put("67", "DENMARK");
		htCountryCode.put("68", "DEPARTMENTAL COLLECTIVITY OF MAYOTTE");
		htCountryCode.put("69", "DHEKELIA");
		htCountryCode.put("70", "DJIBOUTI");

		htCountryCode.put("71", "DOMINICA");
		htCountryCode.put("72", "DOMINICAN REPUBLIC");
		htCountryCode.put("73", "EAST TIMOR (TIMORLASTE)");
		htCountryCode.put("74", "ECUADOR");
		htCountryCode.put("75", "EGYPT");
		htCountryCode.put("76", "ELSALVADOR");
		htCountryCode.put("77", "EQUATORIAL GUINEA");
		htCountryCode.put("78", "ERITREA");
		htCountryCode.put("79", "ESTONIA");
		htCountryCode.put("80", "ETHIOPIA");

		htCountryCode.put("81", "FALKLAND ISLANDS (ISLAS MALVINAS)");
		htCountryCode.put("82", "FAROE ISLANDS");
		htCountryCode.put("83", "FIJI");
		htCountryCode.put("84", "FINLAND");
		htCountryCode.put("85", "FRANCE");
		htCountryCode.put("86", "FRENCH GUIANA");
		htCountryCode.put("87", "FRENCH POLYNESIA");
		htCountryCode.put("88", "FRENCH SOUTHERN ISLANDS");
		htCountryCode.put("89", "GABON");
		htCountryCode.put("90", "GEORGIA"); //## Newly added for correction Ver1.2 by Akansha

		htCountryCode.put("91", "GERMANY");
		htCountryCode.put("92", "GEURNSEY");
		htCountryCode.put("93", "GHANA");
		htCountryCode.put("94", "GIBRALTAR");
		htCountryCode.put("95", "GREECE");
		htCountryCode.put("96", "GREENLAND");
		htCountryCode.put("97", "GRENADA");
		htCountryCode.put("98", "GUADELOUPE");
		htCountryCode.put("99", "");

		htCountryCode.put("100", "GUAM");

		htCountryCode.put("101", "GUATEMALA");
		htCountryCode.put("102", "GUERNSEY");
		htCountryCode.put("103", "GUINEA");
		htCountryCode.put("104", "GUINEABISSAU");
		htCountryCode.put("105", "GUYANA");
		htCountryCode.put("106", "HAITI");
		htCountryCode.put("107", "HEARD ISLAND AND MCDONALD ISLANDS");
		htCountryCode.put("108", "HONDURAS");
		htCountryCode.put("109", "HONG KONG");
		htCountryCode.put("110", "HOWLAND ISLAND");

		htCountryCode.put("111", "HUNGARY");
		htCountryCode.put("112", "ICELAND");
		htCountryCode.put("113", "INDIA");
		htCountryCode.put("114", "INDONESIA");
		htCountryCode.put("115", "IRAN");
		htCountryCode.put("116", "IRAQ");
		htCountryCode.put("117", "IRELAND");
		htCountryCode.put("118", "ISLE OF MAN");
		htCountryCode.put("119", "ISRAEL");
		htCountryCode.put("120", "ITALY");

		htCountryCode.put("121", "JAMAICA");
		htCountryCode.put("122", "JAN MAYEN");
		htCountryCode.put("123", "JAPAN");
		htCountryCode.put("124", "JARVIS ISLAND");
		htCountryCode.put("125", "JERSEY");
		htCountryCode.put("126", "JOHNSTON ATOLL");
		htCountryCode.put("127", "JORDAN");
		htCountryCode.put("128", "KAZAKHSTAN");
		htCountryCode.put("129", "KENYA");
		htCountryCode.put("130", "KINGMAN REEF");

		htCountryCode.put("131", "KIRIBATI");
		htCountryCode.put("132", "KOREA, NORTH");
		htCountryCode.put("133", "KOREA, SOUTH");
		htCountryCode.put("134", "KOSOVO");
		htCountryCode.put("135", "KUWAIT");
		htCountryCode.put("136", "KYRGYZSTAN");
		htCountryCode.put("137", "LAOS");
		htCountryCode.put("138", "LATVIA");
		htCountryCode.put("139", "LEBANON");
		htCountryCode.put("140", "LESOTHO");

		htCountryCode.put("141", "LIBERIA");
		htCountryCode.put("142", "LIBYA");
		htCountryCode.put("143", "LIECHTENSTEIN");
		htCountryCode.put("144", "LITHUANIA");
		htCountryCode.put("145", "LUXEMBOURG");
		htCountryCode.put("146", "MACAU");
		htCountryCode.put("147", "MACEDONIA");
		htCountryCode.put("148", "MADAGASCAR");
		htCountryCode.put("149", "MALAWI");
		htCountryCode.put("150", "MALAYSIA");

		htCountryCode.put("151", "MALAYSIA (LABUAN)");
		htCountryCode.put("152", "MALDIVES");
		htCountryCode.put("153", "MALI");
		htCountryCode.put("154", "MALTA");
		htCountryCode.put("155", "MARSHALLISLANDS");
		htCountryCode.put("156", "MARTINIQUE");
		htCountryCode.put("157", "MAURITANIA");
		htCountryCode.put("158", "MAURITIUS");
		htCountryCode.put("159", "MAYOTTE");
		htCountryCode.put("160", "UNITED MEXICAN STATES");

		htCountryCode.put("161", "MICRONESIA, FEDERATED STATES OF");
		htCountryCode.put("162", "MIDWAY ISLANDS");
		htCountryCode.put("163", "MOLDOVA");
		htCountryCode.put("164", "MONACO");
		htCountryCode.put("165", "MONGOLIA");
		htCountryCode.put("166", "MONTENEGRO");
		htCountryCode.put("167", "MONTSERRAT");
		htCountryCode.put("168", "MOROCCO");
		htCountryCode.put("169", "MOZAMBIQUE"); //## Newly changed for correction Ver1.2 by Akansha
		htCountryCode.put("170", "MYANMAR (BURMA)");

		htCountryCode.put("171", "NAMIBIA");
		htCountryCode.put("172", "NAURU");
		htCountryCode.put("173", "NAVASSA ISLAND");
		htCountryCode.put("174", "NEPAL");
		htCountryCode.put("175", "NETHERLANDS");
		htCountryCode.put("176", "NETHERLANDS ANTILLES");
		htCountryCode.put("177", "NEW CALEDONIA");
		htCountryCode.put("178", "NEWZEALAND");
		htCountryCode.put("179", "NICARAGUA");
		htCountryCode.put("180", "NIGER");

		htCountryCode.put("181", "NIGERIA");
		htCountryCode.put("182", "NIUE");
		htCountryCode.put("183", "NORFOLK ISLAND");
		htCountryCode.put("184", "NORTHERN MARIANA ISLANDS");
		htCountryCode.put("185", "NORWAY");
		htCountryCode.put("186", "OMAN");
		htCountryCode.put("187", "PAKISTAN");
		htCountryCode.put("188", "PALAU");
		htCountryCode.put("189", "PALMYRA ATOLL");
		htCountryCode.put("190", "PANAMA");

		htCountryCode.put("191", "PAPUA NEW GUINEA");
		htCountryCode.put("192", "PARACEL ISLANDS");
		htCountryCode.put("193", "PARAGUAY");
		htCountryCode.put("194", "PERU");
		htCountryCode.put("195", "PHILIPPINES");
		htCountryCode.put("196", "PITCAIRN ISLANDS");
		htCountryCode
				.put("197", "PITCAIRN, HENDERSON, DUCIE, AND OENO ISLANDS");
		htCountryCode.put("198", "POLAND");
		htCountryCode.put("199", "PORTUGAL");
		htCountryCode.put("200", "PUERTO RICO");

		htCountryCode.put("201", "QATAR");
		htCountryCode.put("202", "REUNION");
		htCountryCode.put("203", "ROMANIA");
		htCountryCode.put("204", "RUSSIA");
		htCountryCode.put("205", "RWANDA");
		htCountryCode.put("206", "SAINT BARTHELEMY");
		htCountryCode.put("207", "SAINT HELENA");
		htCountryCode.put("208", "SAINT KITTS AND NEVIS");
		htCountryCode.put("209", "SAINT LUCIA");
		htCountryCode.put("210", "SAINT MARTIN");

		htCountryCode.put("211", "SAINT PIERRE AND MIQUELON");
		htCountryCode.put("212", "SAINT VINCENT AND THE GRENADINES");
		htCountryCode.put("213", "SAMOA");
		htCountryCode.put("214", "SANMARINO");
		htCountryCode.put("215", "SAO TOME AND PRINCIPE");
		htCountryCode.put("216", "SAUDI ARABIA");
		htCountryCode.put("217", "SENEGAL");
		htCountryCode.put("218", "SERBIA");
		htCountryCode.put("219", "SEYCHELLES");
		htCountryCode.put("220", "SIERRA LEONE");

		htCountryCode.put("221", "SINGAPORE");
		htCountryCode.put("222", "SLOVAKIA");
		htCountryCode.put("223", "SLOVENIA");
		htCountryCode.put("224", "SOLOMON ISLANDS");
		htCountryCode.put("225", "SOMALIA");
		htCountryCode.put("226", "SOUTH AFRICA");
		htCountryCode.put("227", "SOUTH GEORGIA AND SOUTH SANDWICH ISLANDS");
		htCountryCode.put("228", "SPRATLY ISLANDS");
		htCountryCode.put("229", "SPAIN");
		htCountryCode.put("230", "SRI LANKA");

		htCountryCode.put("231", "ST. VINCENT & GRENADINES");
		htCountryCode.put("232", "SUDAN");
		htCountryCode.put("233", "SURINAME");
		htCountryCode.put("234", "SVALBARD");
		htCountryCode.put("235", "SWAZILAND");
		htCountryCode.put("236", "SWEDEN");
		htCountryCode.put("237", "SWITZERLAND");
		htCountryCode.put("238", "SYRIA");
		htCountryCode.put("239", "TAIWAN");
		htCountryCode.put("240", "TAJIKISTAN");

		htCountryCode.put("241", "TANZANIA");
		htCountryCode.put("242",
				"TERRITORIAL COLLECTIVITY OF ST. PIERRE & MIQUELON");
		htCountryCode.put("243", "TERRITORY OF AMERICAN SAMOA");
		htCountryCode.put("244", "TERRITORY OF ASHMORE AND CARTIER ISLANDS");
		htCountryCode.put("245", "TERRITORY OF CHRISTMAS ISLAND");
		htCountryCode.put("246", "TERRITORY OF COCOS (KEELING) ISLANDS");
		htCountryCode.put("247", "TERRITORY OF GUAM");
		htCountryCode
				.put("248", "TERRITORY OF HEARD ISLAND & MCDONALD ISLANDS");
		htCountryCode.put("249", "TERRITORY OF NORFOLK ISLAND");
		htCountryCode.put("250", "THAILAND");

		htCountryCode.put("251", "THE BAHAMAS");
		htCountryCode.put("252", "THE GAMBIA");
		htCountryCode.put("253", "TOGO");
		htCountryCode.put("254", "TOKELAU");
		htCountryCode.put("255", "TONGA");
		htCountryCode.put("256", "TRINIDAD AND TOBAGO");
		htCountryCode.put("257", "TUNISIA");
		htCountryCode.put("258", "TURKEY");
		htCountryCode.put("259", "TURKMENISTAN");
		htCountryCode.put("260", "TURKS AND CAICOS ISLANDS");

		htCountryCode.put("261", "TUVALU");
		htCountryCode.put("262", "UGANDA");
		htCountryCode.put("263", "UKRAINE");
		htCountryCode.put("264", "UNITED ARAB EMIRATES");
		htCountryCode.put("265", "UNITED KINGDOM");
		htCountryCode.put("266", "UNITED STATES VIRGIN ISLANDS");
		htCountryCode.put("267", "UNITED STATES OF AMERICA");
		htCountryCode.put("268", "URUGUAY");
		htCountryCode.put("269", "UZBEKISTAN");
		htCountryCode.put("270", "VANUATU");

		htCountryCode.put("271", "VATICAN CITY (HOLYSEE)");
		htCountryCode.put("272", "VENEZUELA");
		htCountryCode.put("273", "VIETNAM");
		htCountryCode.put("274", "VIRGIN ISLANDS, BRITISH");
		htCountryCode.put("275", "VIRGIN ISLANDS, U.S.");
		htCountryCode.put("276", "WAKE ISLAND");
		htCountryCode.put("277", "WALLIS AND FUTUNA");
		htCountryCode.put("278", "WESTERN SAHARA");
		htCountryCode.put("279", "YEMEN");
		htCountryCode.put("280", "ZAMBIA");

		htCountryCode.put("281", "ZIMBABWE");
		htCountryCode.put("282", "COMBODIA");
		htCountryCode.put("283", "CONGO");
		htCountryCode.put("284", "IVORY COAST");
		htCountryCode.put("285", "WEST INDIES");
		htCountryCode.put("286", "BRITISH VIRGIN ISLANDS");
		//htCountryCode.put("287", "BAHAMAS"); //RPU 2.1, Added new Country code in dropdown list, by Sadhana.

		// *******************************************************
		
		//Newly added for Development as on 01/04/2015 11, 27, 37, 63, 64, 21, 49, 16, 28, 31, 52 & 99
		//new development for FRD1.3 by Akansha
	//	htremittanceCodeReverse.put("COMMISSION", "11");
		htremittanceCodeReverse.put("INTEREST PAYMENT", "27");
		// new development for FRD1.3 by Akansha
//		htremittanceCodeReverse
//		.put("PAYMENTS TO SPORTS PERSON & ARTISTS", "37");
//		htremittanceCodeReverse.put("WINNING FROM HORSE RACES.", "63");
//		htremittanceCodeReverse
//		.put(
//				"WINNING FROM LOTTERIES, CROSSWORD PUZZLES, CARD GAMES AND OTHER GAMES OF ANY SORT.",
//				"64");
		htremittanceCodeReverse
		.put("FEES FOR TECHNICAL SERVICES/ FEES FOR INCLUDED SERVICES",
				"21");
		htremittanceCodeReverse.put("ROYALTY", "49");
		htremittanceCodeReverse.put("DIVIDEND", "16");
		htremittanceCodeReverse.put("INVESTMENT INCOME", "28");
		//htremittanceCodeReverse.put("LONG TERM CAPITAL GAINS", "31");
		htremittanceCodeReverse.put("SHORT TERM CAPITAL GAINS", "52");
		htremittanceCodeReverse.put(
				"OTHER INCOME / OTHER (NOT IN THE NATURE OF INCOME)", "99");
		htremittanceCodeReverse.put("LONG TERM CAPITAL GAIN u/s 115E IN CASE OF NON RESIDENT INDIAN CITIZEN", "66");//rahul CR84532 27Q nature of remmittance 
		htremittanceCodeReverse.put("LONG TERM CAPITAL GAIN u/s 112(1)(c)(iii)", "67");//rahul CR84532 27Q nature of remmittance 
		htremittanceCodeReverse.put("LONG TERM CAPITAL GAIN u/s 112", "68");//rahul CR84532 27Q nature of remmittance 
		htremittanceCodeReverse.put("LONG TERM CAPITAL GAIN u/s 112A", "69");//rahul CR84532 27Q nature of remmittance 
		htremittanceCodeReverse.put("SHORT TERM CAPITAL GAIN u/s 111A", "70");//rahul CR84532 27Q nature of remmittance 
		htremittanceCodeReverse.put("LONG TERM CAPITAL GAIN (OTHERS)", "31");//rahul CR84532 27Q nature of remmittance 
		//**********************************************
		
		// Added by AKANSHA FOR Getting Remmitence Code and Country Code

	/*	htremittanceCodeReverse.put("ADVERTISEMENT FEE", "1");
		htremittanceCodeReverse.put("AMC CHARGES", "2");
		htremittanceCodeReverse.put("ARCHITECTURAL SERVICES", "3");
		htremittanceCodeReverse.put("BANDWIDTH CHARGES", "4");
		htremittanceCodeReverse.put("BROKEREAGE CHARGES", "5");
		htremittanceCodeReverse.put(
				"BUSINESS INCOME OTHER THAN THAT COVERED BY CATEGORIES ABOVE",
				"6");
		htremittanceCodeReverse.put(
				"CARGO HANDLING SERVICES INSPECTION & LOGISTICS SERVICES", "7");
		htremittanceCodeReverse.put("CELLULAR ROAMING CHARGES", "8");
		htremittanceCodeReverse.put("CHARTER HIRE CHARGES (SHIPPING)", "9");
		htremittanceCodeReverse.put("CLEARING & FORWARDING CHARGES", "10");
		htremittanceCodeReverse.put("COMMISSION", "11");
		htremittanceCodeReverse.put("COMMUNICATION CHARGES", "12");
		htremittanceCodeReverse.put("CONSULTING SERVICES", "13");
		htremittanceCodeReverse.put("DESIGNING FEE", "14");
		htremittanceCodeReverse.put("DIRECTORS FEES", "15");
		htremittanceCodeReverse.put("DIVIDEND", "16");
		htremittanceCodeReverse.put("DRILLING", "17");
		htremittanceCodeReverse.put("ENGINEERING SERVICES", "18");
		htremittanceCodeReverse.put("EQUIPMENT RENTAL CHARGES", "19");
		htremittanceCodeReverse.put("FABRICATION SERVICES", "20");
		htremittanceCodeReverse
				.put("FEES FOR TECHNICAL SERVICES/ FEES FOR INCLUDED SERVICES",
						"21");
		htremittanceCodeReverse.put("FREIGHT CHARGES", "22");
		htremittanceCodeReverse.put("INCOME FROM IMMOVEABLE PROPERTY", "23");
		htremittanceCodeReverse
				.put("INCOME FROM SHIPPING, INLAND WATERWAYS OR AIR TRANSPORT",
						"24");
		htremittanceCodeReverse.put("INSTALLATION & COMMISSIONING SERVICES",
				"25");
		htremittanceCodeReverse.put("INSURANCE COMMISSIONS", "26");
		htremittanceCodeReverse.put("INTEREST PAYMENT", "27");
		htremittanceCodeReverse.put("INVESTMENT INCOME", "28");
		htremittanceCodeReverse.put("LEASE PAYMENT", "29");
		htremittanceCodeReverse.put("LICENSING FEE", "30");
		htremittanceCodeReverse.put("LONG TERM CAPITAL GAINS", "31");
		htremittanceCodeReverse.put("MEMBERSHIP FEE", "32");
		htremittanceCodeReverse.put("MOBILESTATION CHARGES", "33");
		htremittanceCodeReverse.put(
				"PAYMENTS FOR SOFTWARE BUNDLED WITH HARDWARE", "34");
		htremittanceCodeReverse.put(
				"PAYMENTS FOR SOFTWARE BUNDLED WITH HARDWARE", "35");
		htremittanceCodeReverse.put(
				"PAYMENTS TO PROFESSORS, TEACHERS OR RESEARCH SCHOLARS", "36");
		htremittanceCodeReverse
				.put("PAYMENTS TO SPORTS PERSON & ARTISTS", "37");
		htremittanceCodeReverse.put(
				"PAYMENTS TO STUDENTS OR BUSINESS APPRENTICE", "38");
		htremittanceCodeReverse.put(
				"PENSIONS(OTHER THAN THOSE RELATED TO PAST EMPLOYMENT)", "39");
		htremittanceCodeReverse.put("PROCESSING CHARGES", "40");
		htremittanceCodeReverse.put("PROFESSIONAL SERVICES", "41");
		htremittanceCodeReverse.put("PURCHASE OF SOFTWARE", "42");
		htremittanceCodeReverse.put("R&D CHARGES", "43");
		htremittanceCodeReverse.put("REGISTRATION CHARGES", "44");
		htremittanceCodeReverse.put("REIMBURSEMENT OF EXPENSES", "45");
		htremittanceCodeReverse.put("REPATRIATION OF SURPLUS FUNDS", "46");
		htremittanceCodeReverse.put("RETAINERSHIP FEES", "47");
		htremittanceCodeReverse.put("RETENTION FEES", "48");
		htremittanceCodeReverse.put("ROYALTY", "49");
		htremittanceCodeReverse.put("SALES AND MARKETING SERVICES", "50");
		htremittanceCodeReverse.put("SEISMIC DATA PROCESSING", "51");
		htremittanceCodeReverse.put("SHORT TERM CAPITAL GAINS", "52");
		htremittanceCodeReverse.put("SOFTWARE LICENCES", "53");
		htremittanceCodeReverse.put("SPONSORSHIP FEES", "54");
		htremittanceCodeReverse.put("SUBSCRIPTION FEES", "55");
		htremittanceCodeReverse.put("SUPERVISION CHARGES", "56");
		htremittanceCodeReverse.put("SURVEY FEES", "57");
		htremittanceCodeReverse.put("TELECASTING SERVICES", "58");
		htremittanceCodeReverse.put("TENDER FEES", "59");
		htremittanceCodeReverse.put("TESTING CHARGES", "60");
		htremittanceCodeReverse.put("TRAINING", "61");
		htremittanceCodeReverse.put("WARRANTY SERVICES", "62");
		htremittanceCodeReverse.put("WINNING FROM HORSE RACES.", "63");
		htremittanceCodeReverse
				.put(
						"WINNING FROM LOTTERIES, CROSSWORD PUZZLES, CARD GAMES AND OTHER GAMES OF ANY SORT.",
						"64");
		htremittanceCodeReverse.put(" CONSULAR RECEIPTS", "65");
		htremittanceCodeReverse.put(
				"OTHER INCOME / OTHER (NOT IN THE NATURE OF INCOME)", "99");
*/
		// *********************************************************

		// Added by Akansha country code

		htCountryCodeReverse.put("AFGHANISTAN", "01");
		htCountryCodeReverse.put("AKROTIRI", "02");
		htCountryCodeReverse.put("ALBANIA", "03");
		htCountryCodeReverse.put("ALGERIA", "04");
		htCountryCodeReverse.put("AMERICAN SAMOA", "05");
		htCountryCodeReverse.put("ANDORRA", "06");
		htCountryCodeReverse.put("ANGOLA", "07");
		htCountryCodeReverse.put("ANGUILLA", "08");
		htCountryCodeReverse.put("ANTARCTICA", "09");
//		htCountryCodeReverse.put("AFGHANISTAN", "1");
//		htCountryCodeReverse.put("AKROTIRI", "2");
//		htCountryCodeReverse.put("ALBANIA", "3");
//		htCountryCodeReverse.put("ALGERIA", "4");
//		htCountryCodeReverse.put("AMERICAN SAMOA", "5");
//		htCountryCodeReverse.put("ANDORRA", "6");
//		htCountryCodeReverse.put("ANGOLA", "7");
//		htCountryCodeReverse.put("ANGUILLA", "8");
//		htCountryCodeReverse.put("ANTARCTICA", "9");
		htCountryCodeReverse.put("ANTIGUA AND BARBUDA", "10");
		htCountryCodeReverse.put("ARGENTINA", "11");
		htCountryCodeReverse.put("ARMENIA", "12");
		htCountryCodeReverse.put("ARUBA", "13");
		htCountryCodeReverse.put("ASHMORE AND CARTIER ISLANDS", "14");
		htCountryCodeReverse.put("AUSTRALIA", "15");
		htCountryCodeReverse.put("AUSTRIA", "16");
		htCountryCodeReverse.put("AZERBAIJAN", "17");
		htCountryCodeReverse.put("BAHRAIN", "18");
		htCountryCodeReverse.put("BAILIWICK OF GUERNSEY", "19");
		htCountryCodeReverse.put("BAILIWICK OF JERSEY", "20");
		htCountryCodeReverse.put("BAKER ISLAND", "21");
		htCountryCodeReverse.put("BANGLADESH", "22");
		htCountryCodeReverse.put("BARBADOS", "23");
		htCountryCodeReverse.put("BELARUS", "24");
		htCountryCodeReverse.put("BELGIUM", "25");
		htCountryCodeReverse.put("BELIZE", "26");
		htCountryCodeReverse.put("BENIN PORTO", "27");
		htCountryCodeReverse.put("BERMUDA", "28");
		htCountryCodeReverse.put("BHUTAN", "29");
		htCountryCodeReverse.put("BOLIVIA", "30");
		htCountryCodeReverse.put("BOSNIAAND HERZEGOVINA", "31");
		htCountryCodeReverse.put("BOTSWANA", "32");
		htCountryCodeReverse.put("BOUVET ISLAND", "33");
		htCountryCodeReverse.put("BRAZIL", "34");
		htCountryCodeReverse.put("BRITISH INDIAN OCEAN TERRITORY", "35");
		htCountryCodeReverse.put("BRUNEI", "36");
		htCountryCodeReverse.put("BULGARIA", "37");
		htCountryCodeReverse.put("BURKINA FASO", "38");
		htCountryCodeReverse.put("BURUNDI", "39");
		htCountryCodeReverse.put("CAMBODIA", "40");
		htCountryCodeReverse.put("CAMEROON", "41");
		htCountryCodeReverse.put("CANADA", "42");
		htCountryCodeReverse.put("CAPE VERDE", "43");
		htCountryCodeReverse.put("CAYMAN ISLANDS", "44");
		htCountryCodeReverse.put("CENTRAL AFRICAN REPUBLIC", "45");
		htCountryCodeReverse.put("CHAD", "46");
		htCountryCodeReverse.put("CHILE", "47");
		htCountryCodeReverse.put("CHINA", "48");
		htCountryCodeReverse.put("CHRISTMAS ISLAND", "49");
		htCountryCodeReverse.put("CLIPPERTON ISLAND", "50");
		htCountryCodeReverse.put("COCOS (KEELING) ISLANDS", "51");
		htCountryCodeReverse.put("COLOMBIA", "52");
		htCountryCodeReverse.put("COMMONWEALTH OF PUERTO RICO", "53");
		htCountryCodeReverse.put(
				"COMMONWEALTH OF THE NORTHERN MARIANA ISLANDS", "54");
		htCountryCodeReverse.put("COMOROS", "55");
		htCountryCodeReverse.put("CONGO,DEMOCRATIC REPUBLIC OF THE", "56");
		htCountryCodeReverse.put("CONGO,REPUBLIC OF THE", "57");
		htCountryCodeReverse.put("COOK ISLANDS", "58");
		htCountryCodeReverse.put("CORAL SEA ISLANDS", "59");
		htCountryCodeReverse.put("CORAL SEA ISLANDS TERRITORY", "60");
		htCountryCodeReverse.put("COSTA RICA", "61");
		htCountryCodeReverse.put("COTE D'IVOIRE", "62");
		htCountryCodeReverse.put("CROATIA", "63");
		htCountryCodeReverse.put("CUBA", "64");
		htCountryCodeReverse.put("CYPRUS", "65");
		htCountryCodeReverse.put("CZECH REPUBLIC", "66");
		htCountryCodeReverse.put("DENMARK", "67");
		htCountryCodeReverse.put("DEPARTMENTAL COLLECTIVITY OF MAYOTTE", "68");
		htCountryCodeReverse.put("DHEKELIA", "69");
		htCountryCodeReverse.put("DJIBOUTI", "70");
		htCountryCodeReverse.put("DOMINICA", "71");
		htCountryCodeReverse.put("DOMINICAN REPUBLIC", "72");
		htCountryCodeReverse.put("EAST TIMOR (TIMORLASTE)", "73");
		htCountryCodeReverse.put("ECUADOR", "74");
		htCountryCodeReverse.put("EGYPT", "75");
		htCountryCodeReverse.put("ELSALVADOR", "76");
		htCountryCodeReverse.put("EQUATORIAL GUINEA", "77");
		htCountryCodeReverse.put("ERITREA", "78");
		htCountryCodeReverse.put("ESTONIA", "79");
		htCountryCodeReverse.put("ETHIOPIA", "80");
		htCountryCodeReverse.put("FALKLAND ISLANDS (ISLAS MALVINAS)", "81");
		htCountryCodeReverse.put("FAROE ISLANDS", "82");
		htCountryCodeReverse.put("FIJI", "83");
		htCountryCodeReverse.put("FINLAND", "84");
		htCountryCodeReverse.put("FRANCE", "85");
		htCountryCodeReverse.put("FRENCH GUIANA", "86");
		htCountryCodeReverse.put("FRENCH POLYNESIA", "87");
		htCountryCodeReverse.put("FRENCH SOUTHERN ISLANDS", "88");
		htCountryCodeReverse.put("GABON", "89");
		htCountryCodeReverse.put("GEORGIA", "90");
		htCountryCodeReverse.put("GERMANY", "91");
		htCountryCodeReverse.put("GEURNSEY", "92");
		htCountryCodeReverse.put("GHANA", "93");
		htCountryCodeReverse.put("GIBRALTAR", "94");
		htCountryCodeReverse.put("GREECE", "95");
		htCountryCodeReverse.put("GREENLAND", "96");
		htCountryCodeReverse.put("GRENADA", "97");
		htCountryCodeReverse.put("GUADELOUPE", "98");
		htCountryCodeReverse.put("", "99");
		htCountryCodeReverse.put("GUAM", "100");
		htCountryCodeReverse.put("GUATEMALA", "101");
		htCountryCodeReverse.put("GUERNSEY", "102");
		htCountryCodeReverse.put("GUINEA", "103");
		htCountryCodeReverse.put("GUINEABISSAU", "104");
		htCountryCodeReverse.put("GUYANA", "105");
		htCountryCodeReverse.put("HAITI", "106");
		htCountryCodeReverse.put("HEARD ISLAND AND MCDONALD ISLANDS", "107");
		htCountryCodeReverse.put("HONDURAS", "108");
		htCountryCodeReverse.put("HONG KONG", "109");
		htCountryCodeReverse.put("HOWLAND ISLAND", "110");
		htCountryCodeReverse.put("HUNGARY", "111");
		htCountryCodeReverse.put("ICELAND", "112");
		htCountryCodeReverse.put("INDIA", "113");
		htCountryCodeReverse.put("INDONESIA", "114");
		htCountryCodeReverse.put("IRAN", "115");
		htCountryCodeReverse.put("IRAQ", "116");
		htCountryCodeReverse.put("IRELAND", "117");
		htCountryCodeReverse.put("ISLE OF MAN", "118");
		htCountryCodeReverse.put("ISRAEL", "119");
		htCountryCodeReverse.put("ITALY", "120");
		htCountryCodeReverse.put("JAMAICA", "121");
		htCountryCodeReverse.put("JAN MAYEN", "122");
		htCountryCodeReverse.put("JAPAN", "123");
		htCountryCodeReverse.put("JARVIS ISLAND", "124");
		htCountryCodeReverse.put("JERSEY", "125");
		htCountryCodeReverse.put("JOHNSTON ATOLL", "126");
		htCountryCodeReverse.put("JORDAN", "127");
		htCountryCodeReverse.put("KAZAKHSTAN", "128");
		htCountryCodeReverse.put("KENYA", "129");
		htCountryCodeReverse.put("KINGMAN REEF", "130");
		htCountryCodeReverse.put("KIRIBATI", "131");
		htCountryCodeReverse.put("KOREA, NORTH", "132");
		htCountryCodeReverse.put("KOREA, SOUTH", "133");
		htCountryCodeReverse.put("KOSOVO", "134");
		htCountryCodeReverse.put("KUWAIT", "135");
		htCountryCodeReverse.put("KYRGYZSTAN", "136");
		htCountryCodeReverse.put("LAOS", "137");
		htCountryCodeReverse.put("LATVIA", "138");
		htCountryCodeReverse.put("LEBANON", "139");
		htCountryCodeReverse.put("LESOTHO", "140");
		htCountryCodeReverse.put("LIBERIA", "141");
		htCountryCodeReverse.put("LIBYA", "142");
		htCountryCodeReverse.put("LIECHTENSTEIN", "143");
		htCountryCodeReverse.put("LITHUANIA", "144");
		htCountryCodeReverse.put("LUXEMBOURG", "145");
		htCountryCodeReverse.put("MACAU", "146");
		htCountryCodeReverse.put("MACEDONIA", "147");
		htCountryCodeReverse.put("MADAGASCAR", "148");
		htCountryCodeReverse.put("MALAWI", "149");
		htCountryCodeReverse.put("MALAYSIA", "150");
		htCountryCodeReverse.put("MALAYSIA (LABUAN)", "151");
		htCountryCodeReverse.put("MALDIVES", "152");
		htCountryCodeReverse.put("MALI", "153");
		htCountryCodeReverse.put("MALTA", "154");
		htCountryCodeReverse.put("MARSHALLISLANDS", "155");
		htCountryCodeReverse.put("MARTINIQUE", "156");
		htCountryCodeReverse.put("MAURITANIA", "157");
		htCountryCodeReverse.put("MAURITIUS", "158");
		htCountryCodeReverse.put("MAYOTTE", "159");
		htCountryCodeReverse.put("UNITED MEXICAN STATES", "160");
		htCountryCodeReverse.put("MICRONESIA, FEDERATED STATES OF", "161");
		htCountryCodeReverse.put("MIDWAY ISLANDS", "162");
		htCountryCodeReverse.put("MOLDOVA", "163");
		htCountryCodeReverse.put("MONACO", "164");
		htCountryCodeReverse.put("MONGOLIA", "165");
		htCountryCodeReverse.put("MONTENEGRO", "166");
		htCountryCodeReverse.put("MONTSERRAT", "167");
		htCountryCodeReverse.put("MOROCCO", "168");
		htCountryCodeReverse.put("MOZAMBIQUE", "169");
		htCountryCodeReverse.put("MYANMAR (BURMA)", "170");
		htCountryCodeReverse.put("NAMIBIA", "171");
		htCountryCodeReverse.put("NAURU", "172");
		htCountryCodeReverse.put("NAVASSA ISLAND", "173");
		htCountryCodeReverse.put("NEPAL", "174");
		htCountryCodeReverse.put("NETHERLANDS", "175");
		htCountryCodeReverse.put("NETHERLANDS ANTILLES", "176");
		htCountryCodeReverse.put("NEW CALEDONIA", "177");
		htCountryCodeReverse.put("NEWZEALAND", "178");
		htCountryCodeReverse.put("NICARAGUA", "179");
		htCountryCodeReverse.put("NIGER", "180");
		htCountryCodeReverse.put("NIGERIA", "181");
		htCountryCodeReverse.put("NIUE", "182");
		htCountryCodeReverse.put("NORFOLK ISLAND", "183");
		htCountryCodeReverse.put("NORTHERN MARIANA ISLANDS", "184");
		htCountryCodeReverse.put("NORWAY", "185");
		htCountryCodeReverse.put("OMAN", "186");
		htCountryCodeReverse.put("PAKISTAN", "187");
		htCountryCodeReverse.put("PALAU", "188");
		htCountryCodeReverse.put("PALMYRA ATOLL", "189");
		htCountryCodeReverse.put("PANAMA", "190");
		htCountryCodeReverse.put("PAPUA NEW GUINEA", "191");
		htCountryCodeReverse.put("PARACEL ISLANDS", "192");
		htCountryCodeReverse.put("PARAGUAY", "193");
		htCountryCodeReverse.put("PERU", "194");
		htCountryCodeReverse.put("PHILIPPINES", "195");
		htCountryCodeReverse.put("PITCAIRN ISLANDS", "196");
		htCountryCodeReverse.put(
				"PITCAIRN, HENDERSON, DUCIE, AND OENO ISLANDS", "197");
		htCountryCodeReverse.put("POLAND", "198");
		htCountryCodeReverse.put("PORTUGAL", "199");
		htCountryCodeReverse.put("PUERTO RICO", "200");
		htCountryCodeReverse.put("QATAR", "201");
		htCountryCodeReverse.put("REUNION", "202");
		htCountryCodeReverse.put("ROMANIA", "203");
		htCountryCodeReverse.put("RUSSIA", "204");
		htCountryCodeReverse.put("RWANDA", "205");
		htCountryCodeReverse.put("SAINT BARTHELEMY", "206");
		htCountryCodeReverse.put("SAINT HELENA", "207");
		htCountryCodeReverse.put("SAINT KITTS AND NEVIS", "208");
		htCountryCodeReverse.put("SAINT LUCIA", "209");
		htCountryCodeReverse.put("SAINT MARTIN", "210");
		htCountryCodeReverse.put("SAINT PIERRE AND MIQUELON", "211");
		htCountryCodeReverse.put("SAINT VINCENT AND THE GRENADINES", "212");
		htCountryCodeReverse.put("SAMOA", "213");
		htCountryCodeReverse.put("SANMARINO", "214");
		htCountryCodeReverse.put("SAO TOME AND PRINCIPE", "215");
		htCountryCodeReverse.put("SAUDI ARABIA", "216");
		htCountryCodeReverse.put("SENEGAL", "217");
		htCountryCodeReverse.put("SERBIA", "218");
		htCountryCodeReverse.put("SEYCHELLES", "219");
		htCountryCodeReverse.put("SIERRA LEONE", "220");
		htCountryCodeReverse.put("SINGAPORE", "221");
		htCountryCodeReverse.put("SLOVAKIA", "222");
		htCountryCodeReverse.put("SLOVENIA", "223");
		htCountryCodeReverse.put("SOLOMON ISLANDS", "224");
		htCountryCodeReverse.put("SOMALIA", "225");
		htCountryCodeReverse.put("SOUTH AFRICA", "226");
		htCountryCodeReverse.put("SOUTH GEORGIA AND SOUTH SANDWICH ISLANDS",
				"227");
		htCountryCodeReverse.put("SPRATLY ISLANDS", "228");
		htCountryCodeReverse.put("SPAIN", "229");
		htCountryCodeReverse.put("SRI LANKA", "230");
		htCountryCodeReverse.put("ST. VINCENT & GRENADINES", "231");
		htCountryCodeReverse.put("SUDAN", "232");
		htCountryCodeReverse.put("SURINAME", "233");
		htCountryCodeReverse.put("SVALBARD", "234");
		htCountryCodeReverse.put("SWAZILAND", "235");
		htCountryCodeReverse.put("SWEDEN", "236");
		htCountryCodeReverse.put("SWITZERLAND", "237");
		htCountryCodeReverse.put("SYRIA", "238");
		htCountryCodeReverse.put("TAIWAN", "239");
		htCountryCodeReverse.put("TAJIKISTAN", "240");
		htCountryCodeReverse.put("TANZANIA", "241");
		htCountryCodeReverse.put(
				"TERRITORIAL COLLECTIVITY OF ST. PIERRE & MIQUELON", "242");
		htCountryCodeReverse.put("TERRITORY OF AMERICAN SAMOA", "243");
		htCountryCodeReverse.put("TERRITORY OF ASHMORE AND CARTIER ISLANDS",
				"244");
		htCountryCodeReverse.put("TERRITORY OF CHRISTMAS ISLAND", "245");
		htCountryCodeReverse.put("TERRITORY OF COCOS (KEELING) ISLANDS", "246");
		htCountryCodeReverse.put("TERRITORY OF GUAM", "247");
		htCountryCodeReverse.put(
				"TERRITORY OF HEARD ISLAND & MCDONALD ISLANDS", "248");
		htCountryCodeReverse.put("TERRITORY OF NORFOLK ISLAND", "249");
		htCountryCodeReverse.put("THAILAND", "250");
		htCountryCodeReverse.put("THE BAHAMAS", "251");
		htCountryCodeReverse.put("THE GAMBIA", "252");
		htCountryCodeReverse.put("TOGO", "253");
		htCountryCodeReverse.put("TOKELAU", "254");
		htCountryCodeReverse.put("TONGA", "255");
		htCountryCodeReverse.put("TRINIDAD AND TOBAGO", "256");
		htCountryCodeReverse.put("TUNISIA", "257");
		htCountryCodeReverse.put("TURKEY", "258");
		htCountryCodeReverse.put("TURKMENISTAN", "259");
		htCountryCodeReverse.put("TURKS AND CAICOS ISLANDS", "260");
		htCountryCodeReverse.put("TUVALU", "261");
		htCountryCodeReverse.put("UGANDA", "262");
		htCountryCodeReverse.put("UKRAINE", "263");
		htCountryCodeReverse.put("UNITED ARAB EMIRATES", "264");
		htCountryCodeReverse.put("UNITED KINGDOM", "265");
		htCountryCodeReverse.put("UNITED STATES VIRGIN ISLANDS", "266");
		htCountryCodeReverse.put("UNITED STATES OF AMERICA", "267");
		htCountryCodeReverse.put("URUGUAY", "268");
		htCountryCodeReverse.put("UZBEKISTAN", "269");
		htCountryCodeReverse.put("VANUATU", "270");
		htCountryCodeReverse.put("VATICAN CITY (HOLYSEE)", "271");
		htCountryCodeReverse.put("VENEZUELA", "272");
		htCountryCodeReverse.put("VIETNAM", "273");
		htCountryCodeReverse.put("VIRGIN ISLANDS, BRITISH", "274");
		htCountryCodeReverse.put("VIRGIN ISLANDS, U.S.", "275");
		htCountryCodeReverse.put("WAKE ISLAND", "276");
		htCountryCodeReverse.put("WALLIS AND FUTUNA", "277");
		htCountryCodeReverse.put("WESTERN SAHARA", "278");
		htCountryCodeReverse.put("YEMEN", "279");
		htCountryCodeReverse.put("ZAMBIA", "280");
		htCountryCodeReverse.put("ZIMBABWE", "281");
		htCountryCodeReverse.put("COMBODIA", "282");
		htCountryCodeReverse.put("CONGO", "283");
		htCountryCodeReverse.put("IVORY COAST", "284");
		htCountryCodeReverse.put("WEST INDIES", "285");
		htCountryCodeReverse.put("BRITISH VIRGIN ISLANDS", "286");
		//htCountryCodeReverse.put("BAHAMAS", "287"); //RPU 2.1, Added new Country code in dropdown list, by Sadhana.
		// *******************************************************

		// #################################### END
		// #########################################
	}

	public static boolean validatePAOregNo(String poaRegNo) {

		if (poaRegNo.equals("") || poaRegNo.equals(" "))
			return true;
		try {
			poaRegNo.substring(0, 6);
			int first6Int = Integer.parseInt(poaRegNo.substring(0, 6));
			int lastDigit = Integer.parseInt(poaRegNo.substring(6));
			if (first6Int % 7 != lastDigit)
				return false;
		} catch (Exception e) {
			return false;
		}

		return true;
	}

	/*private static void tokenizeFileHeader(String recStr) throws Exception {
		StringBuffer sb = null;

		try {
			NewStringTokenizer st = new NewStringTokenizer(recStr, "^");
			sb = new StringBuffer();
			String tokstr = st.nextToken();
			int tok = 0;
			int fhHCIndex = fhFieldCount + 1;
			int fvuVersionIndex = fhHCIndex + 1;
			int fvuFLHIndex = fvuVersionIndex + 1;
			int samVersionIndex = fvuFLHIndex + 1;
			int samFLHIndex = samVersionIndex + 1;
			int scmVersionIndex = samFLHIndex + 1;
			int scmFLHIndex = scmVersionIndex + 1;
			while (tokstr != null) {
				// tokstr = tokstr.trim();
				tok++;
				if (tok < fhHCIndex) {
					sb.append(tokstr);
					if (tok != fhFieldCount)
						sb.append('^');
					if (tok == 2) {
						if (!tokstr.equals("FH")) {
							iErrCode = 2;
							// throw new Exception("Invalid File");
							break;
						}
					}
				} else if (tok == fhHCIndex) {
					try {
						fhHC = Long.parseLong(tokstr);

					} catch (NumberFormatException e) {

					}
				} else if (tok == fvuVersionIndex && tokstr.length() > 0) {
					fvuVersion = tokstr;
				} else if (tok == fvuFLHIndex) {
					try {
						fvuFLH = Long.parseLong(tokstr);

					} catch (NumberFormatException e) {

					}
				} else if (tok == samVersionIndex && tokstr.length() > 0) {
					samVersion = tokstr;
				} else if (tok == samFLHIndex) {
					try {
						samFLH = Long.parseLong(tokstr);
					} catch (NumberFormatException e) {

					}
				} else if (tok == scmVersionIndex && tokstr.length() > 0) {
					scmVersion = tokstr;
				} else if (tok == scmFLHIndex) {
					try {
						scmFLH = Long.parseLong(tokstr);
					} catch (NumberFormatException e) {

					}
				}
				tokstr = st.nextToken();
			}
		} catch (Exception e) {
			iErrCode = 2;

			// e.printStackTrace();
			// throw new Exception("Invalid File");
		} finally {
			if (sb.length() > 0) {

				fhString = sb.toString();

			}
		}
	}*/

	/*private static boolean processFVU() {
		if (samVersion != null || samFLH > 0 || scmVersion != null
				|| scmFLH > 0) {
			// changed by manish
			samVersion = null;
			samFLH = 0;
			scmVersion = null;
			scmFLH = 0;

			// In this case SAM version,SAM hash,SCM version,SCM hash
			// should not be present.
			System.out
					.println(samVersion + "---" + samFLH + "---" + scmVersion);
			iErrCode = 2; // Invalid Input file
			return false;
		}

		return processFvuFileLevelHash();
	}*/

	/*private static boolean processFvuFileLevelHash() {

		long rlh;
		long recLevelHC;
		int k;
		long fvuFileLevelHC = 0;
		// long samFileLevelHC = 0;
		long samFileLevelHC = 0; // Added By Subhankar....
		// long scmFileLevelHC = 0;
		try {

			
			k = recStr.lastIndexOf('^');
			recStr = recStr.substring(0, k);
			// scmFileLevelHC = hashCode(recStr, true); //Commented By Subhankar
			// to stop SCM Hash
			k = recStr.lastIndexOf('^', k - 1);
			k = recStr.lastIndexOf('^', k - 1);
			recStr = recStr.substring(0, k);
			// samFileLevelHC = hashCode(recStr, true);

			// samFileLevelHC = hashCode(recStr, true); //Added By Subhankar
			k = recStr.lastIndexOf('^', k - 1);
			k = recStr.lastIndexOf('^', k - 1);
			recStr = recStr.substring(0, k);
			fvuFileLevelHC = hashCode(recStr, true);
			recNo = 1; // added by manish
			fileLevelHC = 0;
			while ((recStr = br.readLine()) != null) {

				recNo++;

				k = recStr.lastIndexOf('^');
				try {
					recLevelHC = Long.parseLong(recStr.substring(k + 1, recStr
							.length()));

				} catch (NumberFormatException e) {
					iErrCode = 6;
					Log.tbaf_log.error("Exception", e);// Input File format
					// Error
					return false;
				}

				recStr = recStr.substring(0, k);
				rlh = hashCode(recStr, true);
				if (rlh != recLevelHC) {
					iErrCode = 7;
					// mismatch of RecordLevel Hash Code at Record: recNo
					return false;
				}
				fileLevelHC += (recNo * recLevelHC);
			}
			fvuFileLevelHC += fileLevelHC;

			if (fvuFileLevelHC != fvuFLH) {
				iErrCode = 9; // mismatch of FVU File Level HashCode
				return false;
			}
			return true;

		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}*/

	// Added by Akansha for rpu 1.1
	public static List financialYearCombo(int j) {

		int year = Calendar.getInstance().get(Calendar.YEAR);
		// System.out.println(year);

		int k = year;
		Calendar nowDate = Calendar.getInstance();
		Calendar toDate = Calendar.getInstance();
		toDate.set(year, 03, 01);
		ArrayList common = new ArrayList();
		ArrayList fY2 = new ArrayList();
		ArrayList fY3 = new ArrayList();
		if (!nowDate.before(toDate)) {
			for (int i = 2007; i <= year; i++) {
				String nik = Integer.toString(i);
				String nikToBeAdded = Integer.toString(i + 1);

				String nikAdd = nikToBeAdded.substring(2);
				fY2.add(new String(nik + "-" + nikAdd));
				fY3.add(new String(nik + "-" + nikToBeAdded));

			}

		} else {
			for (int i = 2007; i <= year - 1; i++) {
				String nik = Integer.toString(i);
				String nikToBeAdded = Integer.toString(i + 1);

				String nikAdd = nikToBeAdded.substring(2);
				fY2.add(new String(nik + "-" + nikAdd));
				fY3.add(new String(nik + "-" + nikToBeAdded));

			}
		}
		if (j == 1){
			//new java development for FRD1.5 by akansha
			java.util.Collections.reverse(fY3);
			common.add(fY3);
		}else {
			common.add(fY2);
			common.add(fY3);
		}
		return common;
	}

	// Added by Akansha
	// For formatting financial year --- Correction
	public static String getFinancialYear(String finyear) {
		String year = finyear.substring(0, 4);
		String year1 = year + "-";
		String nxtyear = finyear.substring(4, 6);
		if ("00".equals(finyear.subSequence(finyear.length() - 2, finyear
				.length()))) {
			int temp = Integer.parseInt(finyear.substring(0, 2)) + 1;
			year1 = year1 + temp + nxtyear;
		} else {
			int temp = Integer.parseInt(finyear.substring(0, 2));
			year1 = year1 + temp + nxtyear;
		}
		//System.out.println("Financial year:" + year1);
		return year1;
	}

	// **************************************************
	// ############################## ADDED BY LATISH FOR DECIMAL ADDITION
	// ####################################

	public static String validateDecimal(String s, int precision) {
		
		

		if (s != null && s.length() != 0) {
			if (precision == 2) {

				s.trim();
				if (s.indexOf(".") == -1) {
					s = s + ".00";
					// System.out.println(s);
				} else {
					String temps = s.substring(s.indexOf("."));

					if (temps.length() == 1) {
						s = s + "00";
					} else if (temps.length() == 2) {
						s = s + "0";
					}

				}
			} else if (precision == 4) {

				s.trim();
				if (s.indexOf(".") == -1) {
					s = s + ".0000";
					// System.out.println(s);
				} else {
					String temps = s.substring(s.indexOf("."));

					if (temps.length() == 1) {
						s = s + "0000";
					} else if (temps.length() == 2) {
						s = s + "000";
					} else if (temps.length() == 3) {
						s = s + "00";
					} else if (temps.length() == 4) {
						s = s + "0";
					}

				}
			}

		}
		return (s);

	}
	
	//rahul CR84532 27Q nature of remmittance start
	public static boolean isdategreaterNatOfRemmittance_2007(String xyz) {  //rahul CR84532 27Q nature of remmittance method created to check the date condition for col 732 DD
		 Date date1 = new Date();
		 Date date2 = new Date();
		 SimpleDateFormat sdfrmt = new SimpleDateFormat("dd/MM/yyyy",Locale.ENGLISH);
		    		    
	try
	{
		    date1 = sdfrmt.parse("01/04/2007");
		    date2 = sdfrmt.parse(xyz);
		     		//(Date) (grpu.model.getValueAt(row_no,15));
		    
		    System.out.println(date1 + "date 1");
	       System.out.println(date2 + "date 2");
		    
		    if(date2.after(date1)){
		            System.out.println("Date2 is after Date1");
		            return true;
		   }
	} 
		    catch (ParseException pe){
				pe.printStackTrace();
			}
	         return false;
		}
	
	//End Rahul

	//Start Rahul
	
	public static boolean isdategreaterNatOfRemmittance_2013(String xyz) {  // CR 84319 rahul method created to check the date condition for col 732 DD
		 Date date1 = new Date();
		 Date date2 = new Date();
		 SimpleDateFormat sdfrmt = new SimpleDateFormat("dd/MM/yyyy",Locale.ENGLISH);
		    		    
	try
	{
		    date1 = sdfrmt.parse("01/04/2013");
		    date2 = sdfrmt.parse(xyz);
		     		//(Date) (grpu.model.getValueAt(row_no,15));
		    
		    System.out.println(date1 + "date 1");
	       System.out.println(date2 + "date 2");
		    
		    if(date2.after(date1)){
		            System.out.println("Date2 is after Date1");
		            return true;
		   }
	} 
		    catch (ParseException pe){
				pe.printStackTrace();
			}
	         return false;
		}
	
	//End Rahul
	
	//Start Rahul
	
	public static boolean isdategreaterNatOfRemmittance_2019(String xyz) {  // CR 84319 rahul method created to check the date condition for col 732 DD
		 Date date1 = new Date();
		 Date date2 = new Date();
		 SimpleDateFormat sdfrmt = new SimpleDateFormat("dd/MM/yyyy",Locale.ENGLISH);
		    		    
	try
	{
		    date1 = sdfrmt.parse("01/04/2019");
		    date2 = sdfrmt.parse(xyz);
		     		//(Date) (grpu.model.getValueAt(row_no,15));
		    
		    System.out.println(date1 + "date 1");
	       System.out.println(date2 + "date 2");
		    
		    if(date2.after(date1)){
		            System.out.println("Date2 is after Date1");
		            return true;
		   }
	} 
		    catch (ParseException pe){
				pe.printStackTrace();
			}
	         return false;
		}
	
	//End Rahul
	
	//rahul CR84532 27Q nature of remmittance end
	
	//new development for FRD1.5 by Akansha
	public static boolean verifyDate(String string) {
		if(string!=null && !"".equals(string)){
			if(string.length()==10){
				 /*
		         * Set preferred date format,
		         * For example MM-dd-yyyy, MM.dd.yyyy,dd.MM.yyyy etc.*/
				
				
				//newly developed for FRD1.5 Ver1.5 by akansha
				if(string.contains("-")){
					string = string.replace("-","/");
				}
				//*********************************************
				
		        SimpleDateFormat sdfrmt = new SimpleDateFormat("dd/MM/yyyy",Locale.ENGLISH);
		        sdfrmt.setLenient(false);
		        /* Create Date object */
		        Date javaDate = null;
		        /* parse the string into date form */
		        try
		        {
		            javaDate = sdfrmt.parse(string); 
		            System.out.println("Date after validation: " + javaDate);
		            return true;
		        }
		        /* Date format is invalid */
		        catch (ParseException e)
		        {
		            System.out.println("The date you provided is in an " +"invalid date format.");
		            return false;
		        }
			}else
				return false;
		}else
			return false;
		
	}
	//************************************************************
	
	//new development for FRD1.5 by akansha
	public static String validRupee(Object rupee){
		String temp="";
		//newly added by akansha RPU1.8
		if(rupee!=null && !"".equals(rupee)){
			if((rupee.toString()).contains(",")){
				temp = rupee.toString();
				temp = temp.replace(",","");
				
			}else
				temp = rupee.toString();
			
			if((rupee.toString()).contains(" ")){
				temp = rupee.toString();
				temp = temp.replace(" ", "");
			}			
			else
				temp = rupee.toString();
			
		
		}
		return temp;
	}
	//************************************************************
	
	
	//newly developed for FRD1.5 Ver1.5 by akansha
	//Cut, Copy & Paste Menus
	public static void textFieldMenus(JTextField textField){
		 	JPopupMenu menu = new JPopupMenu();
	        Action cut = new DefaultEditorKit.CutAction();
	        cut.putValue(Action.NAME, "Cut");
	        cut.putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke("control X"));
	        menu.add( cut );

	        Action copy = new DefaultEditorKit.CopyAction();
	        copy.putValue(Action.NAME, "Copy");
	        copy.putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke("control C"));
	        menu.add( copy );

	        Action paste = new DefaultEditorKit.PasteAction();
	        paste.putValue(Action.NAME, "Paste");
	        paste.putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke("control V"));
	        menu.add( paste );

	        Action selectAll = new SelectAll();
	        menu.add( selectAll );
	        textField.setComponentPopupMenu( menu );
	}
	
	static class SelectAll extends TextAction
    {
        public SelectAll()
        {
            super("Select All");
            putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke("control S"));
        }

        public void actionPerformed(ActionEvent e)
        {
            JTextComponent component = getFocusedComponent();
            component.selectAll();
            component.requestFocusInWindow();
        }
    }
	
	//newly developed for FRD1.5 by akansha
	public static File excelfileupload(GRPU grpu) {

		String filename =  ""; //File.separator
		String filenamestr[]=null;
		JFileChooser fc = new JFileChooser();
		fc.setPreferredSize(new Dimension(500, 326));
		File selFile = null;
		fc.addChoosableFileFilter(grpu.new MyFilterGRPU());
		int result = fc.showOpenDialog(excelupload);
		
		switch (result) {
		case 0: // '\0'
			selFile = fc.getSelectedFile();
			if (!grpu.checkFileName(selFile.getName())) {
				grpu.getMessage("Invalid File Name.\n  :  /  ?  >  <  *  \"  |  \\  ^  _ or Space, not allowed in File Name.");
				selFile = grpu.setSelectedFile(fc);
			} else {
				selFile = fc.getSelectedFile();
				filename = selFile.getName();
				filenamestr = filename.split("_");
				System.out.println("File name:"+filenamestr[1]+"Form mein kya h:"+finyearselect(grpu.jText_disabledFromNum.getText(),grpu.JComboBox_Form_Sub1_finYear.getSelectedItem().toString()));
				if(!grpu.jText_disabledFromNum.getText().equals(filenamestr[0])){
					grpu.getMessage("<html>Incorrect excel file uploaded. <br>Kindly upload suitable excel file according to form number.</html>");
				}
				else if(filenamestr[1].equals(finyearselect(grpu.jText_disabledFromNum.getText(),grpu.JComboBox_Form_Sub1_finYear.getSelectedItem().toString())+".xls")){
					//ExcelUpload.createExcel(selFile,grpu);
				}else if(!filenamestr[1].equals(finyearselect(grpu.jText_disabledFromNum.getText(),grpu.JComboBox_Form_Sub1_finYear.getSelectedItem().toString())+".xls")){
					grpu.getMessage("<html>Incorrect excel file uploaded. <br>Kindly upload suitable excel file according to financial year.</html>");
				}
				
			}
		
			break;

		case 1: // '\001'
			selFile = null;
			
			break;

		case -1:
			selFile = null;
			break;
		}
		if (selFile == null)
			grpu.isOpened = false;
		else
			grpu.isOpened = true;
		grpu.selectedFile = selFile;
		return selFile;
	
	}
	
	//For disabling the filename field of the file chooser dialog box
	 private void disableTextComponent(Container parent, boolean hide) {
	        Component[] c = parent.getComponents();
	        for(int j = 0; j < c.length; j++) {
	            //System.out.println(unpack(c[j]));
	        	 if(unpack(c[j]).equals("MetalFileChooserUI$3")) {
	                 //System.out.println("MetalFileChooserUI$3 = " + c[j]);
	                 //System.out.println("MetalFileChooserUI$3 parent = " +
	                 //                    unpack(c[j].getParent()));
	                 if(hide)
	                     c[j].getParent().setVisible(false);
	                 else    // disable
	                     c[j].setEnabled(false);
	             }
	            
	            if(((Container)c[j]).getComponentCount() > 0) {
	                disableTextComponent((Container)c[j], hide);
	            }
	        }
	    }
	 private String unpack(Component c) {
	        String s = c.getClass().getName();
	        int dot = s.lastIndexOf(".");
	        if(dot != -1)
	            s = s.substring(dot+1);
	        return s;
	    }
	  
	//***********************************************************
	
	//newly developed for selecting the excel according to the financial year
	 public static String finyearselect(String form,String finyear){
		 String formname = form;
		 String finyr = "";
		 int year = Integer.parseInt(finyear.substring(0,4));
		 if("24Q".equals(form)){
			 if(year<=2009){
				 finyr = "2009-2010";
			 }else if(year>=2010 && year<=2011){
				 finyr = "2010-2011";
			 }else if(year>=2012 && year<=2013){
				 finyr = "2012-2013";
			 }else if(year>=2013){
				 finyr = "2013-2014";
			 }
		 }else if("26Q".equals(form)){
			 if(year<=2011){
				 finyr = "2010-2011";
			 }else if(year>=2012 && year<2013){
				 finyr = "2012-2013";
			 }else if(year>=2013){
				 finyr = "2012-2013";
			 }
		 }else if("27Q".equals(form)){
			 if(year<=2011){
				 finyr = "2010-2011";
			 }else if(year>=2012 && year<2013){
				 finyr = "2012-2013";
			 }else if(year>=2013){
				 finyr = "2012-2013";
			 }
		 }else if("27EQ".equals(form)){
			 if(year<=2011){
				 finyr = "2010-2011";
			 }else if(year>=2012 && year<2013){
				 finyr = "2012-2013";
			 }else if(year>=2013){
				 finyr = "2012-2013";
			 }
		 }
		 
		 return finyr;
	 }
	 
	 //******************************************************************
	 
	 
	//newly developed for downloading the file from the local system to the users system
	public void excelfiledownload(String form, String finyear) {
		JFileChooser jf = new JFileChooser();
		String finyrfile = finyearselect(form,finyear);
		jf.setSelectedFile(new File(form+"_"+finyrfile));
		disableTextComponent(jf,false);
		int result = jf.showSaveDialog(null);
		String akki =jf.getSelectedFile().getPath();
		
    	int a = 0;
		String path = "";
		try {
			path = (GRPUMain.class.getProtectionDomain().getCodeSource().getLocation().toURI().getPath());
			a = path.lastIndexOf("/");
			path = path.substring(1, a);
			
			a = akki.lastIndexOf("\\");
			akki = akki.substring(0,a);
			
			//temp code
			
	    		InputStream inStream = null;
	    		OutputStream outStream = null;
			
	    	    File afile =new File(path+"/Excel documents/"+form+"_"+finyrfile+".xls");
	    	    File bfile =new File(akki+"/"+form+"_"+finyrfile+".xls");
	    	    
	    	    //inorder to check whether the excel folder is present inside the RPU folder
	    	    if (!afile.exists()) {
	    	    	JOptionPane.showMessageDialog(null,
	    	    			"Excel cannot be downloaded");
	    	    } else {

				if (bfile.exists() && !bfile.isDirectory()) {
					bfile.delete();

				} else {
					bfile = new File(akki + "/" + form + "_" + finyrfile
							+ ".xls");
				}

				inStream = new FileInputStream(afile);
				outStream = new FileOutputStream(bfile);

				byte[] buffer = new byte[1024];

				int length;
				// copy the file content in bytes
				while ((length = inStream.read(buffer)) > 0) {

					outStream.write(buffer, 0, length);

				}

				inStream.close();
				outStream.close();

				System.out.println("File is copied successful!");
				JOptionPane.showMessageDialog(null,
    	    			"Excel download completed successfully!");
				//to open the file downloaded
				try {
					Desktop.getDesktop().browse(bfile.toURI());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				//***********************************
			}
			//***************
		} catch (URISyntaxException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch(IOException e){
    		e.printStackTrace();
    	}
		
		
	}
	
	//newly added for FRD1.7 by Akansha
	public static boolean checkTINorUINofDed(String value){

		String name = value;
		Pattern pt1 = Pattern.compile(validateAlpha);
		Matcher mh1 = pt1.matcher(name);
		boolean matchFound1 = mh1.matches();
		if (!(matchFound1)) {
			return false;
		}else
		return true;
	}
	//*****************************************************
		
		//**************************************
}